require 'xsd/qname'

# {urn:ControllerService}receiveStatus
class ReceiveStatus < ::Array
end

# {urn:ControllerService}requestStatus
#   requestId - (any)
#   status - Status
class RequestStatus
  attr_accessor :requestId
  attr_accessor :status

  def initialize(requestId = nil, status = [])
    @requestId = requestId
    @status = status
  end
end

# {urn:ControllerService}status
#   nodeId - SOAP::SOAPString
#   value - SOAP::SOAPInt
#   msg - SOAP::SOAPString
class Status
  attr_accessor :nodeId
  attr_accessor :value
  attr_accessor :msg

  def initialize(nodeId = nil, value = nil, msg = nil)
    @nodeId = nodeId
    @value = value
    @msg = msg
  end
end

# {urn:ControllerService}receive
class Receive < ::Array
end

# {urn:ControllerService}receiveNotification
class ReceiveNotification < ::Array
end

# {urn:ControllerService}experimentEnded
class ExperimentEnded
  def initialize
  end
end

# {urn:CommonTypes}message
#   sourceNodeId - SOAP::SOAPString
#   timestamp - SOAP::SOAPDateTime
#   binaryData - SOAP::SOAPBase64
class Message
  attr_accessor :sourceNodeId
  attr_accessor :timestamp
  attr_accessor :binaryData

  def initialize(sourceNodeId = nil, timestamp = nil, binaryData = nil)
    @sourceNodeId = sourceNodeId
    @timestamp = timestamp
    @binaryData = binaryData
  end
end

# {urn:CommonTypes}getNetwork
class GetNetwork
  def initialize
  end
end

# {urn:CommonTypes}getNetworkResponse
#   m_return - SOAP::SOAPString
class GetNetworkResponse
  def m_return
    @v_return
  end

  def m_return=(value)
    @v_return = value
  end

  def initialize(v_return = nil)
    @v_return = v_return
  end
end
