require 'ControllerService.rb'
require 'soap/mapping'

module ControllerServiceMappingRegistry
  EncodedRegistry = ::SOAP::Mapping::EncodedRegistry.new
  LiteralRegistry = ::SOAP::Mapping::LiteralRegistry.new
  NsCommonTypes = "urn:CommonTypes"
  NsControllerService = "urn:ControllerService"

  EncodedRegistry.register(
    :class => ReceiveStatus,
    :schema_type => XSD::QName.new(NsControllerService, "receiveStatus"),
    :schema_element => [
      ["status", ["RequestStatus[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  EncodedRegistry.register(
    :class => RequestStatus,
    :schema_type => XSD::QName.new(NsControllerService, "requestStatus"),
    :schema_element => [
      ["requestId", [nil, XSD::QName.new(nil, "requestId")]],
      ["status", ["Status[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  EncodedRegistry.register(
    :class => Status,
    :schema_type => XSD::QName.new(NsControllerService, "status"),
    :schema_element => [
      ["nodeId", ["SOAP::SOAPString", XSD::QName.new(nil, "nodeId")]],
      ["value", ["SOAP::SOAPInt", XSD::QName.new(nil, "value")], [0, 1]],
      ["msg", ["SOAP::SOAPString", XSD::QName.new(nil, "msg")], [0, 1]]
    ]
  )

  EncodedRegistry.register(
    :class => Receive,
    :schema_type => XSD::QName.new(NsControllerService, "receive"),
    :schema_element => [
      ["msg", ["Message[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  EncodedRegistry.register(
    :class => ReceiveNotification,
    :schema_type => XSD::QName.new(NsControllerService, "receiveNotification"),
    :schema_element => [
      ["msg", ["SOAP::SOAPString[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  EncodedRegistry.register(
    :class => ExperimentEnded,
    :schema_type => XSD::QName.new(NsControllerService, "experimentEnded"),
    :schema_element => []
  )

  EncodedRegistry.register(
    :class => Message,
    :schema_type => XSD::QName.new(NsCommonTypes, "message"),
    :schema_element => [
      ["sourceNodeId", ["SOAP::SOAPString", XSD::QName.new(nil, "sourceNodeId")]],
      ["timestamp", ["SOAP::SOAPDateTime", XSD::QName.new(nil, "timestamp")]],
      ["binaryData", ["SOAP::SOAPBase64", XSD::QName.new(nil, "binaryData")]]
    ]
  )

  EncodedRegistry.register(
    :class => GetNetwork,
    :schema_type => XSD::QName.new(NsCommonTypes, "getNetwork"),
    :schema_element => []
  )

  EncodedRegistry.register(
    :class => GetNetworkResponse,
    :schema_type => XSD::QName.new(NsCommonTypes, "getNetworkResponse"),
    :schema_element => [
      ["v_return", ["SOAP::SOAPString", XSD::QName.new(nil, "return")]]
    ]
  )

  LiteralRegistry.register(
    :class => ReceiveStatus,
    :schema_type => XSD::QName.new(NsControllerService, "receiveStatus"),
    :schema_element => [
      ["status", ["RequestStatus[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => RequestStatus,
    :schema_type => XSD::QName.new(NsControllerService, "requestStatus"),
    :schema_element => [
      ["requestId", [nil, XSD::QName.new(nil, "requestId")]],
      ["status", ["Status[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => Status,
    :schema_type => XSD::QName.new(NsControllerService, "status"),
    :schema_element => [
      ["nodeId", ["SOAP::SOAPString", XSD::QName.new(nil, "nodeId")]],
      ["value", ["SOAP::SOAPInt", XSD::QName.new(nil, "value")], [0, 1]],
      ["msg", ["SOAP::SOAPString", XSD::QName.new(nil, "msg")], [0, 1]]
    ]
  )

  LiteralRegistry.register(
    :class => Receive,
    :schema_type => XSD::QName.new(NsControllerService, "receive"),
    :schema_element => [
      ["msg", ["Message[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => ReceiveNotification,
    :schema_type => XSD::QName.new(NsControllerService, "receiveNotification"),
    :schema_element => [
      ["msg", ["SOAP::SOAPString[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => ExperimentEnded,
    :schema_type => XSD::QName.new(NsControllerService, "experimentEnded"),
    :schema_element => []
  )

  LiteralRegistry.register(
    :class => Message,
    :schema_type => XSD::QName.new(NsCommonTypes, "message"),
    :schema_element => [
      ["sourceNodeId", ["SOAP::SOAPString", XSD::QName.new(nil, "sourceNodeId")]],
      ["timestamp", ["SOAP::SOAPDateTime", XSD::QName.new(nil, "timestamp")]],
      ["binaryData", ["SOAP::SOAPBase64", XSD::QName.new(nil, "binaryData")]]
    ]
  )

  LiteralRegistry.register(
    :class => GetNetwork,
    :schema_type => XSD::QName.new(NsCommonTypes, "getNetwork"),
    :schema_element => []
  )

  LiteralRegistry.register(
    :class => GetNetworkResponse,
    :schema_type => XSD::QName.new(NsCommonTypes, "getNetworkResponse"),
    :schema_element => [
      ["v_return", ["SOAP::SOAPString", XSD::QName.new(nil, "return")]]
    ]
  )

  LiteralRegistry.register(
    :class => Receive,
    :schema_name => XSD::QName.new(NsControllerService, "receive"),
    :schema_element => [
      ["msg", ["Message[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => ReceiveStatus,
    :schema_name => XSD::QName.new(NsControllerService, "receiveStatus"),
    :schema_element => [
      ["status", ["RequestStatus[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => RequestStatus,
    :schema_name => XSD::QName.new(NsControllerService, "requestStatus"),
    :schema_element => [
      ["requestId", [nil, XSD::QName.new(nil, "requestId")]],
      ["status", ["Status[]", XSD::QName.new(nil, "status")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => ReceiveNotification,
    :schema_name => XSD::QName.new(NsControllerService, "receiveNotification"),
    :schema_element => [
      ["msg", ["SOAP::SOAPString[]", XSD::QName.new(nil, "msg")], [1, nil]]
    ]
  )

  LiteralRegistry.register(
    :class => ExperimentEnded,
    :schema_name => XSD::QName.new(NsControllerService, "experimentEnded"),
    :schema_element => []
  )

  LiteralRegistry.register(
    :class => GetNetwork,
    :schema_name => XSD::QName.new(NsCommonTypes, "getNetwork"),
    :schema_element => []
  )

  LiteralRegistry.register(
    :class => GetNetworkResponse,
    :schema_name => XSD::QName.new(NsCommonTypes, "getNetworkResponse"),
    :schema_element => [
      ["v_return", ["SOAP::SOAPString", XSD::QName.new(nil, "return")]]
    ]
  )

  LiteralRegistry.register(
    :class => Message,
    :schema_name => XSD::QName.new(NsCommonTypes, "message"),
    :schema_element => [
      ["sourceNodeId", ["SOAP::SOAPString", XSD::QName.new(nil, "sourceNodeId")]],
      ["timestamp", ["SOAP::SOAPDateTime", XSD::QName.new(nil, "timestamp")]],
      ["binaryData", ["SOAP::SOAPBase64", XSD::QName.new(nil, "binaryData")]]
    ]
  )

end
