#!/usr/bin/ruby -w

require 'soap/rpc/driver'  
require 'utils.rb'
require 'ControllerServiceDriver.rb'
require 'base64'

def getControllerService()
    controllerService = Controller.new();
    controllerService.options["protocol.http.protocol_version"] = "HTTP/1.0"
    controllerService.streamhandler.client.receive_timeout = 180
    controllerService.wiredump_dev = STDOUT
    return controllerService
end

driver=getControllerService();

statusMsg1_1 = Status.new("urn:wisebed:node:ubern:1", 1, "resetNodes status update")
statusMsg1_2 = Status.new("urn:wisebed:node:ubern:2", 1, "resetNodes status update")
statusMsg1_3 = Status.new("urn:wisebed:node:ubern:3", 1, "resetNodes status update")
statusMsg2   = Status.new("urn:wisebed:node:ubern:4", 1, "resetNodes status update")

statusArray = Array.new;
statusArray.push(statusMsg1_1);
statusArray.push(statusMsg1_2);
statusArray.push(statusMsg1_3);

requestStatus1 = RequestStatus.new("request#1", statusArray)
requestStatus2 = RequestStatus.new("request#2", statusMsg2)

array = Array.new;
array.push(requestStatus1);
array.push(requestStatus2);

puts "calling receiveStatus";
receiveStatus = ReceiveStatus.new(array);
getControllerService().receiveStatus(receiveStatus)
puts "receiveStatus call finished";  

# message1 = Message.new("urn:wisebed:node:ubern:1",DateTime.now,Base64.encode64("message 1: hello world"))
# message2 = Message.new("urn:wisebed:node:ubern:1",DateTime.now,Base64.encode64("message 2: hello world"))
# array = Array.new;
# array.push(message1);
# array.push(message2);
# tmessage = Receive.new(array)
# getControllerService().receive(tmessage)
# puts "receive call finished";  



