#!/usr/bin/ruby -w

require 'utils.rb'

require 'mysql'

config = parse_config("/etc/TARWIS.conf");

puts "Accessing MySQL Database";

host = config["MYSQL_DATABASE_HOST"].to_s.strip();
name = config["MYSQL_DATABASE_NAME"].to_s.strip();
user = config["MYSQL_DATABASE_USER"].to_s.strip();
pw   = config["MYSQL_DATABASE_PASSWORD"].to_s.strip();

print "MYSQL_DATABASE_HOST:     " + host + "\n";
print "MYSQL_DATABASE_NAME:     " + name + "\n";
print "MYSQL_DATABASE_USER:     " + user + "\n";
print "MYSQL_DATABASE_PASSWORD: " + pw + "\n";


node_ids = ["urn:wisebed:node:ubern:msb4", "urn:wisebed:node:ubern:msb4", "urn:testnode:2" ];
lines    = ["first output node 1","first output node 2","first output node 2"];
times    = ["2011-03-11T15:28:14","2011-03-11T15:28:14","2011-03-11T15:28:14"];
usecs    = ["999999","999999","999999"];

mysql = Mysql.init()
mysql.connect(host, user,pw)
mysql.select_db(name)
    

def getCurrentExperimentOfNode(node, mysql) 
    query = "SELECT exp_id FROM experiment_network NATURAL JOIN experiment_info WHERE node_urn='" + node.to_s() + "' AND UTC_TIMESTAMP() > exp_start_time AND exp_end_time > UTC_TIMESTAMP();";
    res = mysql.query(query);
    if res.num_rows > 0
      rows = res.fetch_row;
      return rows[0].to_s();
    else 
      return "NO_EXPERIMENT";
    end
    
end    
    
experiment = getCurrentExperimentOfNode("urn:wisebed:node:ubern:msb4", mysql);    
# print "experiment=" + experiment.to_s() + "\n";    
    
    
def writeDataToDB(node_ids, lines, times, usecs, mysql)
    query = "INSERT IGNORE INTO sensornodes_output VALUES"; 
    counter = 0;
    node_ids.length.times do |i|
        node_id = "'" + node_ids[i].to_s() + "'";
        exp_id  = getCurrentExperimentOfNode(node_ids[i], mysql); 
        # print "experiment id=" + exp_id.to_s() + " count=" + exp_id.to_s().scan(/NO\_EXPERIMENT/).count().to_s() + "\n";   
        if exp_id.to_s().scan(/NO\_EXPERIMENT/).count() == 0
            # print "not included\n";
            line    = "'" + lines[i].to_s() + "'";
            time    = "'" + times[i].to_s() + "'";
            usec    = "'" + usecs[i].to_s() + "'";    
            if counter > 0
                query   = query + ","; 
            end
            query   = query + "(" + node_id + "," + exp_id + "," + line + "," + time + "," + usec + ",NULL)\n";        
            counter = counter + 1;  
        end
    end 
    # print "query=" + query + "\n"; 
    if counter > 0
        mysql.query(query);
    end 
end

writeDataToDB(node_ids, lines, times, usecs, mysql);


requestIds = ["req#1","req#1","req#2","req#2"];
nodeIds    = ["urn:testnode:1", "urn:testnode:2", "urn:testnode:1","urn:testnode:2"];
values     = [ 0,100,1,100];
msgs       = ["status update req 1", "status update req 1", "status update req 2", "status update req 2" ];   


def writeStatusMessagesToDB(requestIds, nodeIds, values, msgs, mysql)
      
    query = "REPLACE INTO asynchronousOperation VALUES";
    counter = 0;
    requestIds.length.times do |i|
        request_id = "'" + requestIds[i].to_s() + "'";
        node_id    = "'" + nodeIds[i].to_s() + "'";
        value      = "'" + values[i].to_s() + "'";
        time       = "'" + getUTCTimeString().to_s() + "'";
        if counter > 0
            query  = query + ","; 
        end
        query      = query + "(" + request_id + "," + node_id + "," + value + "," + time + ")\n";        
        counter = counter + 1;  
    end 
    # print "query=" + query + "\n"; 
    mysql.query(query); 
end


writeStatusMessagesToDB(requestIds, nodeIds, values, msgs, mysql);

