#!/usr/bin/ruby -w


require 'utils.rb'  
require 'session_management_service.rb'
require 'net/http'
require 'uri'

  
config = parse_config("/etc/TARWIS.conf")
puts "Starting DUMMY_TESTBED_IMPLEMENTATION..."

trap('INT') {
  exit
}  


fork do
  puts "Starting the SessionManagementService..."
  
  host = (config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[0];
  puts "host: " + host.to_s()
  port = (config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[1];
  puts "port: " + port.to_s() 
  $0 = "sess_mgmt_" + host.to_s + "_" + port.to_s  
  begin
    server    = SessionManagementService.new('SessionManagementService', 'urn:SessionManagementService', host.to_s, port.to_i)  
    trap('INT') {
        server.shutdown
    }    
    server.start 
  rescue Exception => e
    puts "An error occurred: #{$!}"
    print "Exception raised... did you change SESSION_MANAGEMENT_SERVICE_IP_ADDRESS in /etc/TARWIS.conf?\n"
  end
end
