
require 'utils.rb'  
require 'wsn_service.rb'  
require 'soap/rpc/standaloneServer'  
require 'soap/wsdlDriver'
require 'soap/rpc/driver'
require 'utils.rb'
require 'rexml/document'
require 'dummy_node.rb'
require 'xsd/qname'
require 'soap/marshal'
require 'xsd/mapping'
require 'ControllerServiceDriver.rb'
require 'test/unit'
require 'soap/rpc/driver'
require 'webrick'
require 'webrick/httpproxy'
require 'logger'
require 'socket'


class SessionManagementService < SOAP::RPC::StandaloneServer  

  def initialize(* args)  
      super  
      @sensornodes = Hash.new 
      add_method(self, 'getInstance', 'reservation_id', 'controller_url')
      add_method(self, 'free', 'reservationId');
      add_method(self, 'getNetwork') 
      add_servant(self, "urn:CommonTypes"); 
       
       
      @config = parse_config("/etc/TARWIS.conf");
      print "session_management_service started! at " + @port.to_s + "\n";
      @wiseml_file = get_file_as_string(@config["TARWIS_DIRECTORY"].strip + "/DUMMY_TESTBED_IMPLEMENTATION/DUMMY_TESTBED.wiseml");
      @port_inc = 0;
      @base_port = 5000;
      @wsn_service_hash = Hash.new   
      
      @debug = 1;
      
  end
  
  def getHostFromMyURL() 
      host = (@config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[0];
      return host
  end
  
  def getPortFromMyURL() 
      port = (@config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[1];
      return port
  end
  
  def getInstance(reservation_id, controller_url)
      puts "getInstance called... reservation key=" + reservation_id["secretReservationKey"] + " controller url: " + controller_url.to_s + "\n";
      randomPort = @base_port + @port_inc;
      @port_inc = @port_inc + 1;
      puts "spawning new WSNService Instance at port = " + randomPort.to_s;
      url = "http://" + getHostFromMyURL().to_s.strip() + ":" + randomPort.to_s ;
      print "URL: " + url + "\n";
      if (@debug == 0)
          wsdl_path = @config["TARWIS_DIRECTORY"].strip + "WSDL/WSNService.wsdl";
          replaceEndpointURLinWSDL(wsdl_path, url);
          wsn_service_pid = fork do
            puts "Starting the WSNService..."
            $0 = "ruby_wsn_" + randomPort.to_s()
            server = WSNService.new('WSNService', 'urn:WSNService', getHostFromMyURL(), randomPort)  
            trap('INT') {
                server.shutdown
            }  
            Signal.trap("HUP") { 
               puts "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n"; 
               puts "Exiting Dummy WSNService Process\n";
               puts "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n"; 
               server.shutdown
               exit 
            }
            server.start  
          end
          
          @wsn_service_hash[reservation_id["secretReservationKey"]]=wsn_service_pid;
          print "returning url: " + url + "\n";
      end 
      
      return url;    
  end      
  
  def free( reservationId ) 
      print "SessionManagementService::free called! param: " + reservation_id["secretReservationKey"]  + "\n";
      Process.kill("HUP", @wsn_service_hash[reservation_id["secretReservationKey"]]);
  end

  #  This WebService must return a WiseML description of the sensor node
  def getNetwork()     
    return @wiseml_file;
  end
 
end  
