use SOAP::Lite + 'trace'; 

use strict;
use IPC::ShareLite;
use HTTP::Request;
use HTTP::Response;
use Env;
use Pod::WSDL;
use Data::Dumper;
use Date::Parse;
use Date::Manip qw(ParseDate UnixDate);
use SOAP::Data::ComplexType;
use SOAP::DateTime;
use Time::HiRes qw(gettimeofday);


deliverStatusSOAP("urn:ubern:1", 1, "request#1", "status update");

sub getControllerServiceDriver {
   my $driver = SOAP::Lite->service("file:/opt/TARWISServer/ControllerService.wsdl");
   $driver->uri('urn:ControllerService');
   return $driver;
}

sub deliverStatusSOAP {
   my $urn    = $_[0];
   my $status = $_[1];
   my $requestID = $_[2]; 
   my $msg = $_[3];
   # my $client = SOAP::Lite->new();
   # $client->uri('urn:ControllerService');
   # $client->proxy($ENV{'CONTROLLER_SERVICE_URL'}, timeout => $ENV{'SOAP_TIMEOUT'});
   my $soap_message = generateComplexStatusMessage($requestID, $urn, $status, $msg);
   # $client->receiveStatus($soap_message);
   print "deliverStatusSOAP $urn $status $requestID\n";
   getControllerServiceDriver()->receiveStatus($soap_message);
}


sub generateComplexStatusMessage {
  
   my $requestId     = $_[0];
   my $nodeId        = $_[1];
   my $value         = $_[2];
   my $msg           = $_[3];
 
   my $soap_message = SOAP::Data->name("status" => \SOAP::Data->value( 
                                                  SOAP::Data->new(name => "requestId",  value => $requestId), 
                                                  SOAP::Data->name("status" => \SOAP::Data->value( 
                                                                                SOAP::Data->new(name => "nodeId", value => $nodeId, type => "string"),
                                                                                SOAP::Data->new(name => "value", value => $value , type => "int"),
                                                                                SOAP::Data->new(name => "msg", value => $msg , type => "string")
                                                                                                  )
                                                                  ) )
                                       ); 
   return $soap_message;                                    
}

