#!/usr/bin/perl

use IPC::ShareLite;
use HTTP::Request;
use HTTP::Response;
use Pod::WSDL;
use SOAP::Transport::HTTP;
use Proc::Simple;
use IO::Socket;
use POSIX qw(setsid);
use DateTime::Format::MySQL;
use Date::Parse;
use Date::Manip qw(ParseDate UnixDate);
use SOAP::Data::ComplexType;
use SOAP::DateTime;
use Time::HiRes qw(gettimeofday);
use SOAP::Lite;
use Env;

readConfiguration("/etc/TARWIS.conf");

print "Test Program for Compliance with WSDL-File retrieved from UZL Nov/Dec 2009\n";

my $ip   = &Utils::getHostFromURL($ENV{"CONTROLLER_SERVICE_URL"});
my $port = &Utils::getPortFromURL($ENV{"CONTROLLER_SERVICE_URL"});

print "ControllerService is at host: " . $ip   ."\n"; 
print "ControllerService is at port: " . $port ."\n";
 
 
 
print "Connecting to WSNService...\n";
my $wsdlDriver = SOAP::Lite->service("file:/opt/TARWISServer/WSNService.wsdl");
print "getNetwork = " . $wsdlDriver->getNetwork() . "\n";


sub getNeighbourhoodController {
    my $node = $_[0];
    return @neighbors;
}


sub readConfiguration {
     # read the configuration
     my $conf = $_[0];
     
     if(!-e $conf || !-r $conf) {
        print "Configuration file: $conf does not exist!\n";
        return 0;
     }
     
     open(CONFIG, $conf)  or return 0;   
     while (<CONFIG>) {
         chomp;                                       # no newline
         s/#.*//;                                     # no comments
         s/^\s+//;                                    # no leading white
         s/\s+$//;                                    # no trailing white
         next unless length;                          # anything left?
         my ($var, $value) = split(/\s*=\s*/, $_, 2);
         $ENV{"$var"} = $value;
     } 
     return 1;
}
