#!/usr/bin/ruby -w


require 'net/http'
require 'uri'

require '/opt/TARWISServer/UBERN_TESTBED_IMPLEMENTATION/utils.rb';
require '/opt/TARWISServer/UBERN_TESTBED_IMPLEMENTATION/session_management_service.rb';
  
config = parse_config("/etc/TARWIS.conf")
puts "Starting RUBY SESSION_MANAGER"


trap('INT') {
  exit
}  


fork do
  host = (config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[0];
  puts "host: " + host.to_s()
  port = (config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[1];
  newPort = port.to_i() + 1;
  puts "port: " + newPort.to_s(); 
  $0 = "sess_mgmt_" + host.to_s + "_" + newPort.to_s  
  begin
    server    = SessionManagementService.new('SessionManagementService', 'urn:SessionManagementService', host.to_s, newPort.to_i)  
    trap('INT') {
        server.shutdown
    }    
    server.start.wiredump_dev = STDOUT
    server.start 
  rescue Exception => e
    puts "An error occurred: #{$!}"
    print "Exception raised... did you change SESSION_MANAGEMENT_SERVICE_IP_ADDRESS in /etc/TARWIS.conf?\n"
  end
end

