<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'><?php
include '../include/menue.php';
?></div>
<!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div
	id='pageContent' class='pageContent'><?php
	require_once('../include/configurations.php');
	require_once("../include/classes.inc.php");
	require_once("../include/functions.php");
	require_once('../include/RSService/RSService.php');

	//delete old graph file
	delfile("*.svg");
	delfile("*.dot");
	delfile("*.xml");
	delfile("*.png");
	?> <!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='expSetupCfgInfoBox' class='infoBox'><!-- General information text about the experiment setup ---------------- -->
<div id='expSetupCfgInfoText' class='infoText'>
<p><strong>Inspect Experiment Configuration:</strong> You can inspect
the configuration of an ongoing experiment on this page <br />

</div>
<!-- -------------------------------------------------------------------- -->

<div id='expSetupCfgCrossLine' class='crossLine'>&nbsp;</div>
<!-- -------------------------------------------------------------------- -->

</div>
<!-- end div container 'infoBox' --> <!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='expSetupCfgContentBox' class='contentBox'><?php
Db::getInstance()->selectDB("wsn_info");

if(!empty($_POST['exp_id'])) {
    $myExp = Db::getInstance()->getExperimentConfiguration($_POST['exp_id']);
    $snIDs = Db::getInstance()->getNodesOfExperiment($_POST['exp_id']);
    //echo "<pre>";
    //print_r($myExp);
    //echo "</pre>";
    //exit;
}

//get the selected node IDs from the $myRes structure
$snIDs = array();
if(!empty($myExp['exp_nodes']))
{
    foreach($myExp['exp_nodes'] as $expNode)
    {
        $snIDs[$expNode['node_urn']] = $expNode;
    }
}

$expNetworkName = "expNet_" . $myExp['exp_id'];
$expNetwork = new Network($expNetworkName);
foreach($snIDs as $snID => $snValue)
{
    $expNetwork->addSensorNodeFromDB($snID);
}

$imgArray = array();
$imageQueryString = "SELECT image_id, image_name, image_file_name, exp_user_unique_id FROM images;";
$res = mysql_query($imageQueryString);
while ($line = mysql_fetch_assoc($res))
{
    array_push($imgArray, $line);
}


echo "<div id='expSetupCfgImageSelectForm' class='formularBox'>";
echo "<strong>Selected Nodes:</strong><br/><br/>";
echo "<table>";
echo "<colgroup>";
echo "<col width='120'>";
echo "<col width='150'>";
echo "</colgroup>";

//create the dop-down menues for the selected nodes
//initial menue (snIDs from the $_POST array from expSetupSelect.php)
if(!empty($snIDs))
{
    foreach($snIDs as $snID => $snImgProp)
    {
        echo "<tr>" . "<td>";
        echo $snID .": </td><td><select name='snNodes[" . $snID . "]' size='1'>\n";
            foreach($imgArray as $imageProps)
            {
                if($snImgProp['image_id'] == $imageProps['image_id'])
                {
                    echo "<option selected value = '" . $imageProps['image_id'] . "," . $imageProps['image_name'] . "'>" . $imageProps['image_name'] . "</option>\n";
                }
            }
        echo "</select>";
        echo "</td>" . "</tr>";
    }
}
echo "</table>";
echo "</div>";  //end div container 'formularBox' (for ImgSel)

// -- div container 'formularBox' (for ExpMod)
echo "<div id='expSetupCfgExpModForm' class='formularBox'>";
echo "<strong>Experiment Configuration:</strong><br/><br/>";
echo "<table>";
echo "<tr>";
echo "<td>" . "ID:" . "</td>";
echo "<td>" . "<input name='exp_id' type='text' value='" . $myExp['exp_id'] . "' readonly size='35' style='background-color: grey'>" . "</td>";
echo "</tr>";
echo "<tr>";
echo "<td>" . "Name:" . "</td>";
echo "<td>";
echo "<input name='exp_name' type='text' value='" . $myExp['exp_name'] . "' size='35' readonly style='background-color: grey'>";
if($myExp['exp_visibility'] == 0)
{
    echo " public experiment <input type='checkbox' name='exp_visibility' value='1' readonly>";
}
else
{
    echo " public experiment <input type='checkbox' name='exp_visibility' value='1' checked readonly>";
}
echo "</td>";
echo "</tr>";
echo "<tr>";
echo "<td>" . "Description:" . "</td>";
echo "<td>" . "<textarea name='exp_desc' cols='50' rows='10' readonly style='background-color: grey'>" . $myExp['exp_description'] . "</textarea>" . "</td>";
echo "</tr>";
echo "<tr>";
echo "<td>" . "Start:" . "</td>";
echo "<td>" . "<input name='exp_start_time' type='text' value='" . $myExp['exp_start_time'] . "' readonly style='background-color: grey'>" . "</td>";
echo "</tr>";
echo "<tr>";
echo "<td>" . "End:" . "</td>";
echo "<td>" . "<input name='exp_end_time' type='text' value='" . $myExp['exp_end_time'] . "' readonly style='background-color: grey'>" . "</td>";
echo "</tr>";
echo "<tr>";
echo "<td>" . "Runs:" . "</td>";
echo "<td>";
echo " <select name='iterations'>";

$diffTimeSec = timeToSec($myExp['exp_end_time']) - timeToSec($myExp['exp_start_time']);
$currNumOfIteration = $myExp['exp_runs'];
$secPerRun = round($diffTimeSec / $currNumOfIteration);
echo "<option value='" . $currNumOfIteration . "' ";
echo "selected='selected'";
echo ">" . $currNumOfIteration . " (" . secToTime($secPerRun) . " per run) " . "</option>";

echo "</select>";
echo "</td>";
echo "</tr>";
echo "</table>";
echo "<br/>";

echo "<table>";
echo "<tr>";
echo "<td><strong>Automated Command Input:</strong></td>";
echo "</tr>";
echo "</table>";
echo "<br/>";

echo "<table border='1'>";
echo "<tr>";
echo "<td><strong>node</strong></td><td><strong>command</strong></td><td><strong>t-t0 [s]</strong></td>";
echo "</tr>";

$commandsArray = Db::getInstance()->getAutomatedCommands($myExp['exp_id']);

foreach($commandsArray as $commandEntry)
{
    echo "</td>";
    echo "<td style='padding-right:15pt;'>" . $commandEntry['node_urn'] . "</td><td style='padding-right:15pt;'>" . $commandEntry['command'] . "</td><td align='center'>" . $commandEntry['seconds_after_flash'] . "</td>";
    echo "</tr>";
}
echo "</table>";
echo "<br/>";
echo "<br/>";

echo "</table>";
echo "</div>";  //end div container 'formularBox' (for ExpCfg)
echo "</form>"; // end formular for image selection and exp configuration


  echo "<div id='expSetupModNetGraph' class='netGraphSmall'" . "style='background-image:url(" . $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME']. ");background-repeat:no-repeat;padding-right:10pt;'>";
      $graphFormat = "svg";
      $graphFile = "./" . $expNetworkName . "Graph." . $graphFormat;
      $graphResNet = new NetworkGraph($expNetworkName, $expNetwork);
      $graphResNet->drawGraph();
    
      if (!file_exists($graphFile)) {
          echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
      } 
      $graphFilePrefix = "./" . $expNetworkName . "Graph";
      $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
      exec($command);
    
      echo "<img src='" . $graphFilePrefix . ".png'>";
      echo "</div>";  //end div container 'netGraphSmall' (for expSetupModNetGraph)

//-----------------------------------------------------------------------
?></div>
<!-- end div container 'contentBox' --> <!-- ********************************************************************** -->


</div>
<!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
</body>
</html>
<!-- ********************************************************************** -->
