<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include './resMenue.php';
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
<?php
require_once('../include/configurations.php');
require_once("../include/classes.inc.php");
require_once("../include/functions.php");

//delete old graph and tree files
delfile("*.svg");
delfile("*.dot");
delfile("*.xml");
delfile("*.png");

$netName = $config['TESTBED_NAME'];
$net = new Network($netName, $config);
$net->getCompleteSnNetworkFromDB();       //get sensor network including the positions
?>

<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='resTestbedMapInfoBox' class='infoBox'>
  <!-- Information text about the experiment (name, id, start, end, description) -->
  <div id='resTestbedMapInfoText' class='infoText'>
    <?php
    
      if(empty($net->sensornodes))              // exit, if there are no sensor nodes in DB
      {
        echo "<p><font color='#FF000'>" . "<strong>Error:</strong> No sensor nodes in the database!" . "</font></p>";
      	exit;
      }
      if(checkAccessRights($_SERVER['personUniqueID'], "viewNetwork"))
      {
        echo "<p><strong>Testbed Map:</strong> The node locations of the testbed <strong>" . $config['TESTBED_NAME'] . "</strong> are displayed in the map below</p>";
      }
      else
      {
        echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to view the testbed!" . "</font></p>";
        exit;
      }
    ?>
  </div>
  
  <div id='resCrossLine' class='crossLine'>
    &nbsp;
  </div>

</div> <!-- end div container 'infoBox' -->



<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='resTestbedMapContentBox' class='contentBox'>
<?php
// -- div container 'netGraphSmall' (for expSetupCfgNetGraph)
echo "<div id='resTestbedMapNetGraph' class='netGraphSmall'" . "style='background-image:url(" . $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME']. ");background-repeat:no-repeat;padding-right:10pt;'>";
  $graphFormat = "svg";
  $graphFile = "./" . $netName . "Graph." . $graphFormat;
  $graphResNet = new NetworkGraph($netName, $net);
  $graphResNet->drawGraph();
 if (!file_exists($graphFile)) {
            echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
      } 
      $graphFilePrefix = "./" . $netName . "Graph";
      $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
      exec($command);
      echo "<img src='" . $graphFilePrefix .".png" . "'>";
  //}
echo "</div>";  //end div container 'netGraphSmall' (for resTestbedMapNetGraph)

// -- div container 'netTree' (for expSetupCfgNetTree)
echo "<div id='resTestbedMapNetTree' class='netTree'>";
  $netTree = NetTreeExpSetup::getInstance();
  $netFileName = "./" . $netName . ".xml";
  $netTree->generateNetworkTree($net, $netFileName);
?>
<!-- end php section --> <!-- javascript for tree building and returning node selection -->
<script type="text/javascript">
  tree = new dhtmlXTreeObject(document.getElementById('resTestbedMapNetTree'),"100%","",0);
  tree.setImagePath("../include/dhtmlxtree/codebase/imgs/");
  tree.enableCheckBoxes(false);
  tree.enableDragAndDrop(false);
  tree.enableThreeStateCheckboxes(false);
  tree.enableHighlighting(true);
  tree.loadXML("<?php echo $netFileName ?>");
</script> <!-- end javascript for tree building and returning node selection -->
<?php
    echo "</div>";  //end div container 'netTree' (for resTestbedMapNetTree)
?>

</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->