<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include 'testbedManMenu.php';
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
  <?php
	  require_once("../include/classes.inc.php");
	  require_once('../include/snSOAPCom.php');
	  require_once("../include/functions.php");

	  //delete old graph files	  
	  delfile("*.svg");
	  delfile("*.dot");
	  delfile("*.png");
	  
	  //select DB
	  Db::getInstance()->selectDB("wsn_info");
	?>

	
<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='testbedManWSNInfoBox' class='infoBox'>
  <!-- Information text about the images (name, version, platform, description, file, etc) -->
  <div id='expSetupUploadInfoText' class='infoText'>
  <?php
    if(checkAccessRights($_SERVER['personUniqueID'], "maintainTARWIS"))
    {
      if(empty($faultstring))
      {
        echo "<p><strong>Managing Testbed WSN:</strong> You can create a new sensor node. Please fill the form with all required information. This information are stored in the database. If you select an existing sensor node, you can update the information or delete the sensor node from the database.</p>";
      }
      else
      {
        echo "<p><font color='#FF000'>" . $faultstring . "</font></p>";
      }
    }
    else
    {
      echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to administrate the " . $config['TESTBED_NAME'] . "</font></p>";
      exit;
    }
  ?>
  </div>
  <!-- -------------------------------------------------------------------- -->
  
  <div id='testbedManWSNCrossLine' class='crossLine'>
    &nbsp;
  </div>
  <!-- -------------------------------------------------------------------- -->

</div> <!-- end div container 'infoBox' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='testbedManWSNContentBox' class='contentBox'>
<?php
  $wsnManNetName = "WSN_ManNetwork";
  $wsnManNet = new Network($wsnManNetName);
  $wsnManNet->getCompleteSnNetworkFromDB();
?>
 

<div id='wsnManForm' class='formularBox'>
  <?php
  
    if(!empty($_POST) && $_POST['snSubmit'] != "")  
    {
      if($_POST['snSubmit'] == "Create New Sensornode")
      {
        $selSnID = Db::getInstance()->addNewSensorNode($_POST);
        $wsnManNet->getCompleteSnNetworkFromDB();               //update net structur for drop down menue
        addUpdateSensorNodeSOAPED($selSnID, $_POST['x3D'], $_POST['y3D'], $_POST['z3D']);
      }
      else if($_POST['snSubmit'] == "Update Sensornode")
      {
        $selSnID = Db::getInstance()->updateSnConfiguration($_POST);
        $wsnManNet->getCompleteSnNetworkFromDB();               //update net structur for drop down menue
      }
      else if($_POST['snSubmit'] == "Delete Sensornode")
      {
        Db::getInstance()->deleteSensorNode($_POST);
        $selSnID = "0";
        $wsnManNet->getCompleteSnNetworkFromDB();               //update net structur for drop down menue
       }
    }  
  
    echo "<form enctype='multipart/form-data' name='wsnManForm' action='' method='POST'>";
    $snArray = array();    //snArray is used to fill the drop down menu with the avail sensor nodes
    //first line ist for adding a new sensor node
    $addLine = array('sn_id' => 0, 'sn_name' => 'Add New Sensor Node', 'sn_type' => '...');
    array_push($snArray, $addLine);
    if(!empty($wsnManNet->sensornodes))
    {
      foreach($wsnManNet->sensornodes as $key => $val)
      {
        $snLine = array('sn_id' => $val->id, 'sn_name' => $val->name, 'sn_type' => $val->type);
        $snArray[$key] = $snLine;
      }
    }
      
    echo "<strong>Avaliable Sensor Nodes in the Database:</strong><br>";
    echo "<select name='snSel' onChange='Javascript:wsnManForm.submit()'>";
    
    //which was the last seleteced sensor node in the drop down menu
    if(!empty($_POST) && $selSnID == "")
    {
     $tmp = split(",", $_POST['snSel']);
      $selSnID = $tmp[0];
    }    
    
    //filling the drop down menu with the available sensor nodes
    foreach($snArray as $val)
    {      
      if(!empty($_POST) && $selSnID == $val['sn_id'])
      {
        echo "<option selected value = '" . $val['sn_id'] . "," . $val['sn_name'] . "'>" . $val['sn_name'] . " (" . $val['sn_type'] . ")" . "</option>";
      }
      else
      {
        echo "<option value = '" . $val['sn_id'] . "," . $val['sn_name'] . "'>" . $val['sn_name'] . " (" . $val['sn_type'] . ")" . "</option>";
      }
    }      
    echo "</select>";
    
    //get the whole list of possible properties
    $propArray = Db::getInstance()->getAllProperties();
      
    // if a sensor node was selected
    if(!empty($_POST))
    {
      if(!empty($selSnID)) //if an sensor node is selected from the drop down menue
      {
        $selSN = new Sensornode($selSnID);
        $selSN->updateSn3DPosFromDB();

        //table to arrange the formular
        echo "<table border='0'>";    
        echo "<tr><td width='120px'>ID:</td>";
        echo "<td width='370px'><input type='text' name='id' size='20' value='" . $selSN->id . "'></td></tr>";
        echo "<tr><td width='120px'>3D-Position:</td>";        
        echo "<td width='370px'><input type='text' name='x3D' size='3' value='" . $selSN->x3D . "'><input type='text' name='y3D' size='3' value='" . $selSN->y3D . "'><input type='text' name='z3D' size='3' value='" . $selSN->z3D . "'></td></tr>";
         
        //iterate over all possible properties
        foreach($propArray as $key => $property)
        {
          //check if there is for value for this property ($key) for this sensor node ($selSN)
          if($selSN->information[$key] != "") //if yes, print a filled form field
          {
            $prop = $selSN->information[$key];
            echo "<tr><td width='120px'>" . $prop['description'] . ":</td>";
            echo "<td width='370px'><input type='text' name='prop[" . $prop['prop_id'] . "] size='18' value='" . $prop['value'] . "'>" . " " . $prop['time'] . "</td></tr>";
          }
          else                                //if no, print an empty form field
          {
            echo "<tr><td width='120px'>" . $property['description'] . ":</td>";
            echo "<td width='370px'><input type='text' name='prop[" . $property['prop_id'] . "] size='18'>" . "</td></tr>";
          }
        }
        echo "</table>";
        echo "<input type='submit' name='snSubmit' value='Update Sensornode'>";
        echo "<input type='submit' name='snSubmit' value='Delete Sensornode'>";
      }
      else //if the "add sensor node" line is selected (sn_id == 0)
      {
        echo "<table border='0'>";    
        echo "<tr><td width='120px'>ID:</td>";
        echo "<td width='370px'><input type='text' name='id' size='18'> [urn]</td></tr>";
        echo "<tr><td width='120px'>3D-Position:</td>";        
        echo "<td width='370px'><input type='text' name='x3D' size='3'><input type='text' name='y3D' size='3'><input type='text' name='z3D' size='3'> [int, int, int]</td></tr>";
          
        //print empty form fields for the properties
        foreach($propArray as $key => $property)
        {
          echo "<tr><td width='120px'>" . $property['description'] . ":</td>";
          echo "<td width='370px'><input type='text' name='prop[" . $property['prop_id'] . "] size='18'>" . "</td></tr>";
        }
        echo "</table>";
        echo "<input type='submit' name='snSubmit' value='Create New Sensornode'>";
      }
    }
    else // if $_POST array is empty (at first click, nothing is selected)
    {
      echo "<table border='0'>";    
      echo "<tr><td width='120px'>ID:</td>";
      echo "<td width='370px'><input type='text' name='id' size='18'> [urn]</td></tr>";
      echo "<tr><td width='120px'>3D-Position:</td>";        
      echo "<td width='370px'><input type='text' name='x3D' size='3'><input type='text' name='y3D' size='3'><input type='text' name='z3D' size='3'> [int, int, int]</td></tr>";
          
      //print empty form fields for the properties
      foreach($propArray as $key => $property)
      {
        echo "<tr><td width='120px'>" . $property['description'] . ":</td>";
        echo "<td width='370px'><input type='text' name='prop[" . $property['prop_id'] . "] size='18'>" . "</td></tr>";
      }
      echo "</table>";
      echo "<input type='submit' name='snSubmit' value='Create New Sensornode'>";
    }          
    echo "</form>";         
  ?>
</div> <!-- end div 'wsnManForm' -->

<!-- div container 'netGraph' --------------------------------------------- -->
<div id='expSetupSelNetGraph' class='netGraphSmall' <?php echo "style='background-image:url(" . $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME']. ");background-repeat:no-repeat;padding-right:10pt;'";?> >
  <?php 
	  $graphFormat = "svg";
	  $graphFile = "./" . $wsnManNetName . "Graph." . $graphFormat;
      $graphManWSN = new NetworkGraph($wsnManNetName, $wsnManNet);
      $graphManWSN->drawGraph();
    
      if (!file_exists($graphFile)) {
            echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
      } 
      $graphFilePrefix = "./" . $wsnManNetName . "Graph";
      $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
      exec($command);
      echo "<img src='" . $graphFilePrefix .".png" . "'>";
 	?>
</div> <!-- end div container 'netGraph' -->


</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->

