<?php
class Network
{
  public $name;
  public $meshnodes = array();
  public $sensornodes = array();
  public $mnMnConnections = array();
  public $mnSnConnections = array();
  public $snSnConnections = array();

//*****************************************************************************

//Constructor:
//  - construct the network object
//  - the network contains MNs, SNs and connections between all entities
//  - all the required information are requested from the wsn_info DB
public function __construct($name)
{
  if($name == "")
  {
    throw new Exception('Name for network required');
  }
  $this->name = $name;
}

//*****************************************************************************
		
//getCompleteNetworkFromDB:
//  - the network contains MNs, SNs and connections between all entities
//  - all the required information are requested from the wsn_info DB
public function getCompleteNetworkFromDB()
{
  Db::getInstance()->selectDB();
  //get all sensornodes including their positions
  $query = "SELECT * FROM sensornodes_positions";
  $result = mysql_query($query)
    or die("Request failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $divide = explode(":", $line['node_urn']);    
    $snID = $line['node_urn'];
    $sn = new Sensornode($snID);
    $sn->x3D = $line['x'];
    $sn->y3D = $line['y'];
    $sn->z3D = $line['z'];
    $this->sensornodes[$divide[sizeof($divide)-1]] = $sn;
  }
  if(!empty($this->sensornodes))
  {
    ksort($this->sensornodes);
  }
      
  //get all connections between sensornodes
  $query = "SELECT * FROM sensornode_network";
  $result = mysql_query($query)
    or die("Request failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $tmpArray = array('node_urn' => $line['node_urn'], 'node_urn_neighbor' => $line['node_urn_neighbor'], 'ETX' => $line['ETX']);
    $this->snSnConnections[] =$tmpArray;
  }
}


//*****************************************************************************
//	getCompleteSnNetworkFromDB:
//  - the network contains SNs and connections between the sensor nodes
//  - all the required information are requested from the wsn_info DB
public function getCompleteSnNetworkFromDB()
{
  unset($this->sensornodes);
    
  Db::getInstance()->selectDB();  

  //get all sensornodes including their positions
  $query = "SELECT * FROM sensornodes_positions";
  $result = mysql_query($query)
    or die("Request failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $divide = explode(":", $line['node_urn']);  //splits the urn (UBERN:xx)
    $snID = $line['node_urn'];
    $sn = new Sensornode($snID);
    $sn->x3D = $line['x'];
    $sn->y3D = $line['y'];
    $sn->z3D = $line['z'];
    //echo "node: " . $snID . " x="  . $sn->x3D . "<br>";
    $this->sensornodes[$divide[sizeof($divide)-1]] = $sn;       //stores it under the number from the urn in the array
  }                                             // (because of sorting the array
  if(!empty($this->sensornodes))
  {
    ksort($this->sensornodes);                  //sorts the array according the numbers in the urn (UBERN:xx)
  }
      
  //get all connections between sensornodes
  $query = "SELECT * FROM sensornode_network";
  $result = mysql_query($query)     or die("Request failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $tmpArray = array('node_urn' => $line['node_urn'], 'node_urn_neighbor' => $line['node_urn_neighbor'], 'ETX' => $line['ETX']);
    $this->snSnConnections[] =$tmpArray;
  }  
}


//*****************************************************************************

//addSensorNodeFromDB:
//  - select a certain sensornode from the DB 
//  - get the position data and adds them to the sensornode object
public function addSensorNodeFromDB($snID)
{
  //get a sensornode including its position
  $query = "SELECT * FROM sensornodes_positions WHERE node_urn='" . $snID . "';";
  
  $result = mysql_query($query)
    or die("Request failed: " . mysql_error());
    
    
  $line = mysql_fetch_assoc($result);

  //echo "<pre>";  
  //echo "blubb<br>";
  //print_r($line); 
  //echo "</pre>";  
  
  if(empty($line)) {
  	echo "addSensorNodeFromDB: Sensornodes_positions not found in database!<br>"; 
  }
  
  $divide = explode(":", $line['node_urn']);  //splits the urn (UBERN:xx)
  $snID = $line['node_urn'];                    
  $sn = new Sensornode($snID);
  $sn->x3D = $line['x'];
  $sn->y3D = $line['y'];
  $sn->z3D = $line['z'];
  $this->sensornodes[$divide[sizeof($divide)-1]] = $sn;       //stores it under the number from the urn in the array
}


//*****************************************************************************

//addAllSnSnConnections:
//  - select a connections from the DB for the sensor nodes of the current
//    network
//  - add them to the snSnConnections array
public function addAllSnSnConnections()
{
  foreach($this->sensornodes  as $key => $val)
  {
    $snID = $val->id;
    //get all neighbors for the sensornodes of the current network
    $query = "SELECT * FROM sensornode_network WHERE node_urn='" . $snID . "';";
    $result = mysql_query($query)
      or die("Request failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($result))
    {
      $divide = explode(":", $line['node_urn_neighbor']); //splits the urn (UBERN:xx)
      $neigborID = $divide[sizeof($divide)-1];                            //take the number from the urn
      if($this->sensornodes[$neigborID] == "")            //if the neighbor is not in the network
      {                                                   // (if a node is not used in an experiment)
        //echo "is not existing! <br>";
      }
      else
      {
        $tmpArray = array('node_urn' => $line['node_urn'], 'node_urn_neighbor' => $line['node_urn_neighbor'], 'ETX' => $line['ETX']);
        $this->snSnConnections[] =$tmpArray;
      }
    }
  }
}


//*****************************************************************************

//addSensorNodeFromDB:
//  - select a certain sensornode from the DB 
//  - calls the function getOutputFromDB_Number with given number of lines
//    which get the output from DB and adds them to the sensornode object
public function addSensorNodeOutputFromDB($snID, $numOfLines)
{
  $this->sensornodes[$snID]->getOutputFromDB_Number($numOfLines);
}


//*****************************************************************************
		
public function updateSensorNodes()
{
  Db::getInstance()->selectDB();
  
  //get all sensornodes including their positions
  $query = "SELECT * FROM sensornodes_positions";
  $result = mysql_query($query)
    or die("Request failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $snID = $line['node_urn'];
    $sn = new Sensornode($snID);
    $sn->x3D = $line['x'];
    $sn->y3D = $line['y'];
    $sn->z3D = $line['z'];
    $this->sensornodes[$snID] = $sn;
  }
}
		
//*****************************************************************************
		
public function getAllSensornodes()
{
  return $this->sensornodes;
}

//*****************************************************************************

public function getAllSnMnConnections()
{
  return $this->snMnConnections;
}
		
//*****************************************************************************

public function getAllSnSnConnections()
{
  return $this->snSnConnections;
}

//*****************************************************************************
		
}
?>
