<?php
class Sensornode
{
	public $id;
	public $name;
	public $type;
	public $information = array();    //array with all properties
	public $sensors = array();        //assoc array with sensors and their values
	public $output;
	public $x3D;
	public $y3D;
	public $z3D;
	public $x2D;
	public $y2D;
	public $alive;

	public $neighbours = array();

	//*****************************************************************************

	public function __construct($snID)
	{
		if($snID == "")
		{
			throw new Exception('Sensornode ID required');
		}
		$this->id = $snID;                                  //set the ID
		$divide = explode(":", $snID);                      //splits the urn (UBERN:xx)
		$snName = "ID: " . $divide[sizeof($divide)-1];
		$this->name = $snName;                              //set the name
		$this->type = $this->getPropertyFromDB("nodeType");     //set the type
		$this->information = $this->getInformationFromDB(); //set the propInfo
	}

	//*****************************************************************************

	public function getInformationFromDB()
	{
		//select DB
		Db::getInstance()->selectDB("wsn_info");

		//get the all properties from DB and write it into $this->information
		$query = "SELECT prop_id, value, time, usecs FROM sensornodes WHERE node_urn='" . $this->id . "'";
		$result = mysql_query($query)
		or die("Sensornode.getInformationFromDB: Request for properties failed: " . $query . " :: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$propID = $line['prop_id'];
			$value = $line['value'];
			$time = $line['time'];
			$usecs = $line['usecs'];

			$query2 = "SELECT description FROM properties WHERE prop_id =" . $propID . ";";
			$result2 = mysql_query($query2)
			or die("Sensornode.getInformationFromDB2: Request for property description failed: " . mysql_error());
			while ($line2 = mysql_fetch_assoc($result2))
			{
				$propDesc = $line2['description'];
			}
			if($value != "")
			{
				$resultArray = array('prop_id' => $propID, 'description' => $propDesc, 'value' => $value, 'time' => $time, 'usecs' => $usecs);
				$informationArray[$propID] = $resultArray;
			}
		}
		return $informationArray;
	}

	//*****************************************************************************

	public function getPropertyFromDB($propName)
	{
		//select DB
		Db::getInstance()->selectDB("wsn_info");

		$query = "SELECT node_urn, value, description FROM sensornodes, properties WHERE node_urn = '" . $this->id . "' AND sensornodes.prop_id = properties.prop_id AND properties.description = '" . $propName . "';";
		$result = mysql_query($query)
		or die("Sensornode.getPropertyFromDB: Request for property value failed: " . mysql_error());
		$line = mysql_fetch_assoc($result);
		$propValue = $line['value'];
		return $propValue;
	}


	//*****************************************************************************

	public function getOutputFromDB_Number($numOfLines, $experiment_id)
	{
		$resultString = "";

		//select DB
		Db::getInstance()->selectDB("wsn_info");

		$query = "SELECT line, time, usecs from sensornodes_output WHERE node_urn ='". $this->id . "' AND exp_id = '" . $experiment_id . "' ORDER BY rowindex DESC LIMIT " . $numOfLines . ";";
		$result = mysql_query($query)
		or die("Sensornode.getOutputFromDB_Number: (query=" . $query . "\n) Request for sensor output failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			//$resultString = $line['time'] . "," . $line['usecs'] . ": " . $line['line'] . "<br>" . $resultString;
			$resultString = htmlentities($line['line']) . "<br/>" . $resultString;
		}
		$this->output = $resultString;
	}

	//*****************************************************************************

	public function getOutputFromDB_Duration($startTime, $endTime)
	{
	}

	//*****************************************************************************

	public function getSensorValuesFomDB_LastNumber($sensorName, $numOfValues)
	{
		$resultArray = array();

		//select DB
		Db::getInstance()->selectDB("wsn_info");

		//execute querry
		$query = "SELECT value, time, usecs FROM sensorvalues, properties WHERE sensorvalues.node_urn = '" . $this->id . "' AND sensorvalues.prop_id = properties.prop_id AND properties.description = '" . $sensorName . "' ORDER BY time DESC LIMIT " . $numOfValues . ";";
		$result = mysql_query($query)
		or die("Sensornode.getSensorValuesFomDB_LastNumber: Request for sensor values failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$tmpArray = array('value' => $line['value'], 'time' => $line['time'], 'usecs' => $line['usecs']);
			array_push($resultArray, $tmpArray);
		}

		//sort of the data
		foreach ($resultArray as $key => $row)
		{
			$time[$key]    = $row['time'];
			$usecs[$key] = $row['usecs'];
		}
		array_multisort($time, SORT_ASC, $usecs, SORT_ASC, $resultArray);

		return $resultArray;
	}

	//*****************************************************************************

	public function getSensorValuesFomDB_FirstNumber($sensorName, $numOfValues)
	{
		$resultArray = array();

		//select DB
		Db::getInstance()->selectDB("wsn_info");

		//execute querry
		$query = "SELECT value, time, usecs FROM sensorvalues, properties WHERE sensorvalues.node_urn = '" . $this->id . "' AND sensorvalues.prop_id = properties.prop_id AND properties.description = '" . $sensorName . "' ORDER BY time ASC LIMIT " . $numOfValues . ";";
		$result = mysql_query($query)
		or die("Sensornode.getSensorValuesFomDB_FirstNumber: Request for sensor values failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$tmpArray = array($line['value'], $line['time'], $line['usecs']);
			array_push($resultArray, $tmpArray);
		}
		return $resultArray;
	}

	//*****************************************************************************

	public function getSensorValuesFromDB_Duration($sensorName, $startTime, $endTime)
	{
		$resultArray = array();

		//select DB
		Db::getInstance()->selectDB("wsn_info");

		//execute querry
		$query = "SELECT value, time, usecs FROM sensorvalues, properties WHERE sensorvalues.node_urn = '" . $this->id . "' AND sensorvalues.prop_id = properties.prop_id AND properties.description = '" . $sensorName . "' AND time > '" . $startTime . "'" . ";";
		$result = mysql_query($query)
		or die("Sensornode.getSensorValuesFomDB_FirstNumber: Request for sensor values failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$tmpArray = array($line['value'], $line['time'], $line['usecs']);
			array_push($resultArray, $tmpArray);
		}
		return $resultArray;
	}

	//*****************************************************************************

	// updates type
	public function updateSnTypeFromDB()
	{
		$this->type = $this->getPropertyFromDB("type"); //set the name
	}

	//*****************************************************************************

	// updates 3D pos
	public function updateSn3DPosFromDB()
	{
		//get all sensornodes including their positions
		$query = "SELECT * FROM sensornodes_positions WHERE node_urn ='" . $this->id . "';";

		//echo "SN.updateSn3DPosFromDB: query = " . $query . "<br>";

		$result = mysql_query($query)
		or die("Request failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$this->x3D = $line['x'];
			$this->y3D = $line['y'];
			$this->z3D = $line['z'];
		}
	}

	//*****************************************************************************

	// updates 3D pos
	public function isNodeAlive()
	{
		//get all sensornodes including their positions
		$query = "SELECT * FROM aliveState WHERE node_urn ='" . $this->id . "';";

		$result = mysql_query($query) or die("Request failed: " . mysql_error());
		while ($line = mysql_fetch_assoc($result))
		{
			$this->alive = $line['node_state'];
		}
		return $this->alive;
	}



	//*****************************************************************************

	public function add2DCoordinates($x2D, $y2D)
	{
		$this->x2D = $x2D;
		$this->y2D = $y2D;
	}

	//*****************************************************************************

}
?>