<?php

//delfile
//  - deletes all files using wildcards (e.g. *.xml)
function delfile($str)
{
    foreach(glob($str) as $fn)
    {
        unlink($fn);
    }
}


//###############################################################################
//###############################################################################


//added by Maick
function getSecretAuthenticationKey()
{
    return $_SERVER['HTTP_COOKIE']."@".$_SERVER['SERVER_NAME'];
}

//###############################################################################
//###############################################################################


function xml_attribute($object, $attribute)
{
    if(isset($object[$attribute]))
    {
        return (string) $object[$attribute];
    }
}


//###############################################################################
//###############################################################################


function sortResCallback($arr1, $arr2)
{
    $from1 = $arr1->from;
    $from1Timestamp = strtotime($from1);
    $from2 = $arr2->from;
    $from2Timestamp = strtotime($from2);

    if($from1Timestamp >= $from2Timestamp)
    {
        return 0;
    }
    else
    {
        return 1;
    }
}


//###############################################################################
//###############################################################################


function getNetwork()
{
    global $config;
    $url = $config['SESSION_MANAGEMENT_SERVICE_URL'];
    $client = new SoapClient(NULL,
    array("location" => $url,
                                 "uri"      => "urn:CommonTypes",
                                 "style"    => SOAP_RPC));

    $output = $client->__call("getNetwork",
    array(),
    array("uri" => "urn:CommonTypes",
                                  "soapaction" => "urn:CommonTypes#getNetwork"));
    return $output;
}


//###############################################################################
//###############################################################################


function getMyReservations($from, $to, $userID)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getConfidentialReservationsParam = new getConfidentialReservations();
    $getReservationsParam = new getReservations();
    $getReservationsParam->from = toDateTime($from);
    $getReservationsParam->to   = toDateTime($to);
    $secretAuthenticationKeyParam = new secretAuthenticationKey();
    $secretAuthenticationKeyParam->username = $userID;
    $secretAuthenticationKeyParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $secretAuthenticationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $getConfidentialReservationsParam->period = $getReservationsParam;
    $getConfidentialReservationsParam->secretAuthenticationKey = $secretAuthenticationKeyParam;
    $getConfidentialReservationsRet = $rs->getConfidentialReservations($getConfidentialReservationsParam);
    
    $returnArray = array();
    
    if(count($getConfidentialReservationsRet->reservationData)>0)
    { 
        if(count($getConfidentialReservationsRet->reservationData) == 1)
        {
            $getConfidentialReservationsRet = array($getConfidentialReservationsRet->reservationData);
        }
        else
        {
            $getConfidentialReservationsRet = $getConfidentialReservationsRet->reservationData;
        }
        uasort($getConfidentialReservationsRet, "sortResCallback");
    
        foreach($getConfidentialReservationsRet as $myRes)
        {
                $user = $myRes->data->username; 
                if($userID == $user){
                    array_push($returnArray,$myRes);
                }
        }
    }
            
    return $returnArray;
}

//###############################################################################
//###############################################################################


function getMyReservationsAsTestbedMaintainer_onlyMine($from, $to, $userID)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getConfidentialReservationsParam = new getConfidentialReservations();
    $getReservationsParam = new getReservations();
    $getReservationsParam->from = toDateTime($from);
    $getReservationsParam->to   = toDateTime($to);
    $secretAuthenticationKeyParam = new secretAuthenticationKey();
    $secretAuthenticationKeyParam->username = $userID;
    $secretAuthenticationKeyParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $secretAuthenticationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $getConfidentialReservationsParam->period = $getReservationsParam;
    $getConfidentialReservationsParam->secretAuthenticationKey = $secretAuthenticationKeyParam;
    $getConfidentialReservationsRet = $rs->getConfidentialReservations($getConfidentialReservationsParam);
    
    $returnArray = array();
    
    if(count($getConfidentialReservationsRet->reservationData)>0)
    { 
        if(count($getConfidentialReservationsRet->reservationData) == 1)
        {
            $getConfidentialReservationsRet = array($getConfidentialReservationsRet->reservationData);
        }
        else
        {
            $getConfidentialReservationsRet = $getConfidentialReservationsRet->reservationData;
        }
        uasort($getConfidentialReservationsRet, "sortResCallback");
    
        foreach($getConfidentialReservationsRet as $myRes)
        {
                $user = $myRes->data->username; 
                if($userID == $user){
                    array_push($returnArray,$myRes);
                }
        }
    }
            
    return $returnArray;
}



function getMyReservationsAsTestbedMaintainer_onlyOthers($from, $to, $userID)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getConfidentialReservationsParam = new getConfidentialReservations();
    $getReservationsParam = new getReservations();
    $getReservationsParam->from = toDateTime($from);
    $getReservationsParam->to   = toDateTime($to);
    $secretAuthenticationKeyParam = new secretAuthenticationKey();
    $secretAuthenticationKeyParam->username = $userID;
    $secretAuthenticationKeyParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $secretAuthenticationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $getConfidentialReservationsParam->period = $getReservationsParam;
    $getConfidentialReservationsParam->secretAuthenticationKey = $secretAuthenticationKeyParam;
    $getConfidentialReservationsRet = $rs->getConfidentialReservations($getConfidentialReservationsParam);
    
        
    
    $returnArray = array();
    
    if(count($getConfidentialReservationsRet->reservationData)>0)
    { 
        if(count($getConfidentialReservationsRet->reservationData) == 1)
        {
            $getConfidentialReservationsRet = array($getConfidentialReservationsRet->reservationData);
        }
        else
        {
            $getConfidentialReservationsRet = $getConfidentialReservationsRet->reservationData;
        }
        uasort($getConfidentialReservationsRet, "sortResCallback");
    
        foreach($getConfidentialReservationsRet as $myRes)
        {
                $user = $myRes->data->username; 
                if($userID != $user){
                    array_push($returnArray,$myRes);
                }
        }
    }
    
    //echo "getMyReservationsAsTestbedMaintainer_onlyOthers<pre>";
    //print_r($getConfidentialReservationsRet);
    //echo "</pre>";
    
            
    return $returnArray;
}


//###############################################################################
//###############################################################################


function getAllReservations($from, $to, $userID)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getConfidentialReservationsParam = new getConfidentialReservations();
    $getReservationsParam = new getReservations();
    $getReservationsParam->from = toDateTime($from);
    $getReservationsParam->to   = toDateTime($to);
    $secretAuthenticationKeyParam = new secretAuthenticationKey();
    $secretAuthenticationKeyParam->username = $userID;
    $secretAuthenticationKeyParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $secretAuthenticationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $getConfidentialReservationsParam->period = $getReservationsParam;
    $getConfidentialReservationsParam->secretAuthenticationKey = $secretAuthenticationKeyParam;
    $getConfidentialReservationsRet = $rs->getConfidentialReservations($getConfidentialReservationsParam);
    return $getConfidentialReservationsRet;
}

//###############################################################################
//###############################################################################


function getReservations($from, $to)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getReservationsParam = new getReservations();
    $getReservationsParam->from = toDateTime($from);
    $getReservationsParam->to   = toDateTime($to);
    $getReservationsRet = $rs->getReservations($getReservationsParam);
    return $getReservationsRet;
}

//###############################################################################
//###############################################################################


function getReservation($resKey)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $getReservationParam = new getReservation();
    $secretReservationKeyParam = new secretReservationKey();
    $secretReservationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $secretReservationKeyParam->secretReservationKey = $resKey;
    $getReservationParam->secretReservationKey = $secretReservationKeyParam;
    $getReservationRet = $rs->getReservation($getReservationParam);
    return $getReservationRet;
}

//###############################################################################
//###############################################################################

function makeReservation($resArray, $userID, $resType)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $makeReservationParam = new makeReservation();
    $authenticationDataParam = new secretAuthenticationKey();
    $authenticationDataParam->username = $userID;
    $authenticationDataParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $authenticationDataParam->urnPrefix = $config['URN_PREFIX'];
    $dataParam = new data();
    $dataParam->urnPrefix = $config['URN_PREFIX'];
    $dataParam->username = $userID;
    $dataParam->secretReservationKey = "";
    $reservationParam = new confidentialReservationData();
    $reservationParam->from = toDateTime($resArray['from']);
    $reservationParam->to   = toDateTime($resArray['to']);
    $reservationParam->nodeURNs = $resArray['nodes'];
    $reservationParam->userData = $resType;
    $reservationParam->data = $dataParam;
    $makeReservationParam->authenticationData = $authenticationDataParam;
    $makeReservationParam->reservation = $reservationParam;
    //echo "<pre>";
    //print_r($makeReservationParam);
    //echo "</pre>";
    $makeReservationRet = $rs->makeReservation($makeReservationParam);
    return $makeReservationRet;
}


//###############################################################################
//###############################################################################


function deleteReservation($resKey, $userID)
{
    global $config;
    $rs = new RSService($config['RESERVATION_SYSTEM_DIRECTORY'] . "/RS.wsdl");
    $deleteReservationParam = new deleteReservation();
    $authenticationDataParam = new secretAuthenticationKey();
    $authenticationDataParam->username = $userID;
    $authenticationDataParam->secretAuthenticationKey = getSecretAuthenticationKey();
    $authenticationDataParam->urnPrefix = $config['URN_PREFIX'];
    $secretReservationKeyParam = new secretReservationKey();
    $secretReservationKeyParam->secretReservationKey = $resKey;
    $secretReservationKeyParam->urnPrefix = $config['URN_PREFIX'];
    $deleteReservationParam->authenticationData = $authenticationDataParam;
    $deleteReservationParam->secretReservationKey = $secretReservationKeyParam;
    $deleteReservationRet = $rs->deleteReservation($deleteReservationParam);
}

//###############################################################################
//###############################################################################



function createNodeTypeMap($nodesArr,$defaultType)
{
    $nodeTypeMap  = array();
    //prepare matrice
    if(!empty($nodesArr))
    {
        foreach($nodesArr as $node)
        {
            $nodeUrn = xml_attribute($node, 'id');

            if(array_key_exists("nodeType", $node))
            {
                $nodeTypeMap[$nodeUrn]=(string)$node->nodeType;
            }
            else {
                $nodeTypeMap[$nodeUrn]=$defaultType;
            }
        }
    }
    return $nodeTypeMap;
}

//###############################################################################
//###############################################################################



function getAllTypes($nodeTypeMap)
{
    $types = array();
    foreach ($nodeTypeMap as $urn => $type) {
        if(!in_array($type, $types)) {
            array_push($types, $type);
        }
    }
    return $types;
}


//###############################################################################
//###############################################################################



function createNodeStateMatrice($nodesArr, $resArr, $myResArr, $currDay, $defaultType)
{
    $nodeStateMat = array();
    //prepare matrice
    // iterate over all nodes, set them "free" 
    if(!empty($nodesArr))
    {
        foreach($nodesArr as $node)
        {
            $nodeUrn = xml_attribute($node, 'id');
            $nodeStateMat[$nodeUrn] = array();
            for($i = 0; $i < 96; $i++)
            {
                $nodeStateMat[$nodeUrn][$i]['state'] = 'free';
            }
        }
    }
    else
    {
        return $nodeStateMat;
    }

    // iterate over all reservations
    // = add all reservations
    if(!empty($resArr))
    {

        // if there's just one element, make it a reference. if more, make it an array
        if(count($resArr) == 1 && !is_array($resArr))
        {
            $resArr2[] = $resArr;
        }
        else
        {
            $resArr2 = $resArr;
        }
        
        foreach($resArr2 as $res)
        {
            $from = strtotime($res->from) - strtotime($currDay);
            $fromBlock = floor($from / (15 * 60));
            $to = strtotime($res->to) - strtotime($currDay);
            $toBlock = floor($to / (15 * 60));
            
            //echo "foreach <pre>";
            //print_r($res);
            //echo "</pre>";
            
            if($res->userData == "")
            {
                $state = 'reserved';
            }
            else
            {
                $state = $res->userData;
            }

            $nodeUrns = array();
            if(count($res->nodeURNs) == 1)
            {
                $nodeUrns[] = $res->nodeURNs;
            }
            else
            {
                $nodeUrns = $res->nodeURNs;
            }
            
            foreach($nodeUrns as $urn)
            {
                for($i = $fromBlock; $i <= $toBlock; $i++)
                {
                    $nodeStateMat[$urn][$i]['state'] = $state;
                    $nodeStateMat[$urn][$i]['from']  = secToDateTime(timeToSec($res->from));
                    $nodeStateMat[$urn][$i]['to']    = secToDateTime(timeToSec($res->to));
                }
            }
        }
    }
            

    //add user information for own reservations
    if(!empty($myResArr))
    {
        $myResArr2 = array();
        if(count($myResArr) == 1 && !is_array($myResArr))
        {
            $myResArr2[] = $myResArr;
        }
        else
        {
            $myResArr2 = $myResArr;
        }
        
        //echo "myResArr <pre>";
        //print_r($myResArr2);
        //echo "</pre>";
    

        foreach($myResArr2 as $myRes)
        {
            //echo "foreach myRes <pre>";
            //print_r($myRes);
            //echo "</pre>";
            
            $from = strtotime($myRes->from) - strtotime($currDay);
            $fromBlock = floor($from / (15 * 60));
            $to = strtotime($myRes->to) - strtotime($currDay);
            $toBlock = floor($to / (15 * 60));
            $userID = $myRes->data->username;
            $resKey = $myRes->data->secretReservationKey;

            
            $nodeUrns = array();
            if(count($myRes->nodeURNs) == 1)
            {
                $nodeUrns[] = $myRes->nodeURNs;
            }
            else
            {
                $nodeUrns = $myRes->nodeURNs;
            }
            
            
            foreach($nodeUrns as $urn)
            {
                for($k = $fromBlock; $k <= $toBlock; $k++)
                {
                    //echo "from: " . $myRes->from  . "<br>";
                    //echo "2: " .    timeToSec($myRes->from)  . "<br>";
                    //echo "3: " .    secToDateTime(timeToSec($myRes->from))  . "<br>";
//                    echo "urn:" . $urn . "<br>";
//                    echo "k:" . $k . "<br>";
//                    echo "resKey:" . $resKey . "<br>";
//                    echo "myRes->from:" . $myRes->from . "<br>";
//                    echo "myRes->to:" . $myRes->to . "<br>";
//                    echo "userID:" . $userID . "<br>";
                    $nodeStateMat[$urn][$k]['resKey'] = $resKey;
                    $nodeStateMat[$urn][$k]['userID'] = $userID;
                    $nodeStateMat[$urn][$k]['from'] = secToDateTime(timeToSec($myRes->from));
                    $nodeStateMat[$urn][$k]['to']   = secToDateTime(timeToSec($myRes->to));
                }
            }
        }
    }
    return $nodeStateMat;
}



//###############################################################################
//###############################################################################

function checkAdminRights($userID)
{
    global $config;
    $soapubern = new SoapClient(null,array("location" => $config['SNA_AUTHORIZATION_URL'],
                                         "uri" => "http://testbed.wisebed.eu/api/snaa/v1/",
                                         "soap_version" => SOAP_1_1,
                                         "trace" => 1));
    $result = $soapubern->isAuthorized($userID, "maintainReservation");

    if(strcmp($result, "user is authorized") == 0)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

//###############################################################################
//###############################################################################

function checkAccessRights($userID, $action)
{
    global $config;
    $soapubern = new SoapClient(null,array("location" => $config['SNA_AUTHORIZATION_URL'],
                                         "uri" => "http://testbed.wisebed.eu/api/snaa/v1/",
                                         "soap_version" => SOAP_1_1,
                                         "trace" => 1));
    $result = $soapubern->isAuthorized($userID, $action);

    if(strcmp($result, "user is authorized") == 0)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}


//###############################################################################
//###############################################################################


// returns a string including the table with all days of the month
function getCalendarSheet($m, $y, $day)
{
    if((!$m) || (!$y))
    {
        $m = date("m", mktime());
        $y = date("Y", mktime());
    }

    /*== get what weekday the first is on ==*/
    $tmpd = getdate(mktime(0,0,0,$m,1,$y));
    $month = $tmpd["month"];
    $firstwday= $tmpd["wday"];

    $lastday = getLastDayofMonth($m, $y);

    $nextMonth = $m + 1;
    $nextYear = $y;
    $prevMonth = $m - 1;
    $prevYear = $y;
    if($m == 12)
    {
        $nextMonth = 1;
        $nextYear = $y + 1;
    }
    if($m == 1)
    {
        $prevMonth = 12;
        $prevYear = $y - 1;
    }

    $resString = "";
    $resString = $resString . "<table cellpadding='2' cellspacing='0' border='1'>";
    $resString = $resString .   "<tr>";
    $resString = $resString .     "<td colspan='7' style='background-color:#A50021'>";
    $resString = $resString .       "<table cellpadding='0' cellspacing='0' border='0' style='width:100%'>";
    $resString = $resString .         "<tr>";
    $resString = $resString .           "<th style='width:20px'><a style='color:white;font-weight:bold;text-decoration:none;' href='" . $_SERVER['PHP_SELF'] . "?m=" . $prevMonth . "&y=" . $prevYear . "'>&lt;&lt;</a></th>";
    $resString = $resString .           "<th><span style='font-size:2; color:#FFFFFF'>" . $month . " " . $y . "</span></th>";
    $resString = $resString .           "<th style='width:20px'><a style='color:white;font-weight:bold;text-decoration:none;' href='" . $_SERVER['PHP_SELF'] . "?m=" . $nextMonth . "&y=" . $nextYear . "'>&gt;&gt;</a></th>";
    $resString = $resString .         "</tr>";
    $resString = $resString .       "</table>";
    $resString = $resString .     "</td>";
    $resString = $resString .   "</tr>";
    $resString = $resString .   "<tr>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>Su</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>M</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>T</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>W</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>Th</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>F</span></th>";
    $resString = $resString .     "<th style='width:22px' class='tcell'><span style='font-size:2; color:#A50021'>Sa</span></th>";
    $resString = $resString .   "</tr>";

    $d = 1;
    $wday = $firstwday;
    $firstweek = true;

    /*== loop through all the days of the month ==*/
    while($d <= $lastday)
    {
        /*== set up blank days for first week ==*/
        if ($firstweek)
        {
            $resString = $resString . "<tr>";
            for($i=1; $i<=$firstwday; $i++)
            {
                $resString = $resString . "<td><span style='font-size:2'>&nbsp;</span></td>";
            }
            $firstweek = false;
        }

        /*== Sunday start week with <tr> ==*/
        if ($wday==0)
        {
            $resString = $resString . "<tr>";
        }

        if($d == $day)
        {
            /*== check for event ==*/
            $resString = $resString . "<td class='tcell' style='background-color:#A50021'>";
            $resString = $resString . "<a style='color:white;font-weight:bold;text-decoration:none;' href='" . $_SERVER['PHP_SELF'] . "?m=" . $m . "&y=" . $y . "&d=" . $d . "'>" . $d . "</a>";
            $resString = $resString . "</td>";
        }
        else
        {
            /*== check for event ==*/
            $resString = $resString . "<td class='tcell'>";
            $resString = $resString . "<a style='color:#A50021;text-decoration:none;' href='" . $_SERVER['PHP_SELF'] . "?m=" . $m . "&y=" . $y . "&d=" . $d . "'>" . $d . "</a>";
            $resString = $resString . "</td>";
        }

        /*== Saturday end week with </tr> ==*/
        if ($wday==6)
        {
            $resString = $resString . "</tr>";
        }

        $wday++;
        $wday = $wday % 7;
        $d++;
    }

    $resString = $resString . "</tr></table>";

    return $resString;
}

//###############################################################################
//###############################################################################

/*== get the last day of the month ==*/
function getLastDayofMonth($mon, $year)
{
    for ($tday=28; $tday <= 31; $tday++)
    {
        $tdate = getdate(mktime(0, 0, 0, $mon, $tday, $year));
        if($tdate["mon"] != $mon)
        {
            break;
        }
    }
    $tday--;

    return $tday;
}

//###############################################################################
//###############################################################################


function generateDIV($i, $j, $node_urn)
{
    return "<div id='" . $i . "_" . $j . "' onmousedown='StartDragSelect(this)' ondblclick='doubleClicked(this)' onmouseover='mouseOver(this)' onmouseup='onMouseUp(this)' title='". $node_urn ."' ></div>";
}

//###############################################################################
//###############################################################################

function generateDIV_toModify($i, $j)
{
    return "<div id='" . $i . "_" . $j . "' onmousedown='StartDragSelect(this)' ondblclick='doubleClicked(this)' onmouseover='mouseOver(this)' onmouseup='onMouseUp(this)' tomodify=1></div>";
}

//###############################################################################
//###############################################################################

function generateSelectableDIV($i, $j, $divClass)
{
    return "<div id='" . $i . "_" . $j . "' class='" . $divClass . "' onmousedown='StartDragSelect(this)' ondblclick='doubleClicked(this)' onmouseover='mouseOver(this)' onmouseup='onMouseUp(this)'></div>";
}

//###############################################################################
//###############################################################################

function generateUnselectableDiv($i, $j)
{
    return "<div id='" . $i . "_" . $j . "' value='nonselectable' class='nonselectable'></div>";
}

//###############################################################################
//###############################################################################

function generateEmptyDiv($i, $j)
{
    return "<div id='" . $i . "_" . $j . "' value='nonselectable' class='empty'></div>";
}

//###############################################################################
//###############################################################################

function generateSpecialTypeDiv($i, $j, $type, $user, $key, $from, $to, $isTestbedMaintainer)
{
    $userID = $_SERVER['personUniqueID'];
    if($userID == $user && $type == 'reserved') {
        $type = 'reserved_myself';
    }
    else if($userID == $user && $type == 'reserved_expired') {
        $type = 'reserved_myself_expired';
    }
    else if($userID != $user && $type == 'reserved_other_expired' && !$isTestbedMaintainer ) {
        $type = 'reserved_other_expired';
    }
    else if($userID != $user && $type == 'reserved' && $isTestbedMaintainer) {
        $type = 'reserved_display_user';
    }
    else if($userID != $user && $type == 'reserved') {
        $user = 'other';
    }
    else if($userID != $user && $type == 'maintenance') {
        $user = 'other';
    }
    else if($userID != $user && $type == 'localuser') {
        $user = 'other user';
    }
    return "<div id='" . $i . "_" . $j . "' class='" . $type . "' user='$user' key='$key' from='$from' to='$to' onmouseover='ddrivetip(this);' onmouseout='hideddrivetip()' ></div>";
}

//###############################################################################
//###############################################################################

function timeToSec($time)
{
    $timestamp = strtotime($time);
    return $timestamp;
}

//###############################################################################
//###############################################################################

function secToTime($seconds)
{
    $hours = floor($seconds / 3600);
    $minutes = floor($seconds % 3600 / 60);
    $seconds = $seconds % 60;

    return sprintf("%d:%02d:%02d", $hours, $minutes, $seconds);
}


//###############################################################################
//###############################################################################

function secToDateTime($seconds)
{
    return toDateTime(gmdate("Y-m-d H:i:s", $seconds));
}

//###############################################################################
//###############################################################################

function toDateTime($time)
{
    $t = explode(" ", $time);
    return $t[0] . "T" . $t[1] . "Z";
}

//###############################################################################
//###############################################################################



function generateNodeValuesComponent()
{
        require_once('../include/configurations.php');
        require_once('../include/classes.inc.php');
        require_once("../include/functions.php");
        require_once('../include/snSOAPCom.php');

        $wsnManNetName = "WSN_ManNetwork";
        $wsnManNet = new Network($wsnManNetName);
        $wsnManNet->getCompleteSnNetworkFromDB();
        echo "<form enctype='multipart/form-data' name='wsnManForm' action='' method='POST'>";
        $snArray = array();
        $addLine = array('sn_id' => 0, 'sn_name' => 'Choose Node', 'sn_type' => '...');
        array_push($snArray, $addLine);
        if(!empty($wsnManNet->sensornodes))
        {
                foreach($wsnManNet->sensornodes as $key => $val)
                {
                        $snLine = array('sn_id' => $val->id, 'sn_name' => $val->name, 'sn_type' => $val->type);
                        $snArray[$key] = $snLine;
                }
        }
        echo "<strong>Current Sensor Node Values</strong><br>";
        echo "<select name='snSel' onChange='Javascript:wsnManForm.submit()'>";

        //which was the last seleteced sensor node in the drop down menu
        if(!empty($_POST) && $selSnID == "")
        {
                $tmp = split(",", $_POST['snSel']);
                $selSnID = $tmp[0];
        }

        foreach($snArray as $val)
        {
                if(!empty($_POST) && $selSnID == $val['sn_id'])
                {
                        echo "<option selected value = '" . $val['sn_id'] . "," . $val['sn_name'] . "'>" . $val['sn_name'] . " (" . $val['sn_type'] . ")" . "</option>";
                }
                else
                {
                        echo "<option value = '" . $val['sn_id'] . "," . $val['sn_name'] . "'>" . $val['sn_name'] . " (" . $val['sn_type'] . ")" . "</option>";
                }
        }
        echo "</select>";

        $propArray = Db::getInstance()->getAllProperties();

        if(!empty($_POST))
        {
                if(!empty($selSnID))
                {
                        $selSN = new Sensornode($selSnID);
                        $selSN->updateSn3DPosFromDB();

                        echo "<table border='0'>";
                        echo "<tr><td width='120px'>ID:</td>";
                        echo "<td width='370px'><input type='text' name='id' size='18' value='" . $selSN->id . "'></input></td></tr>";
                        echo "<tr><td width='120px'>3D-Position:</td>";
                        echo "<td width='370px'><input type='text' name='x3D' size='3' value='" . $selSN->x3D . "'></input><input type='text' name='y3D' size='3' value='" . $selSN->y3D . "'></input><input type='text' name='z3D' size='3' value='" . $selSN->z3D . "'></input></td></tr>";

                        foreach($propArray as $key => $property)
                        {
                                if($selSN->information[$key] != "")
                                {
                                        $prop = $selSN->information[$key];
                                        echo "<tr><td width='120px'>" . $prop['description'] . ":</td>";
                                        echo "<td width='370px'><input type='text' name='prop[" . $prop['prop_id'] . "] size='18' value='" . $prop['value'] . "'></input>" . " " . $prop['time'] . "</td></tr>";
                                }
                                else
                                {
                                        echo "<tr><td width='120px'>" . $property['description'] . ":</td>";
                                        echo "<td width='370px'><input type='text' name='prop[" . $property['prop_id'] . "] size='18'></input>" . "</td></tr>";
                                }
                        }
                        echo "</table>";
                }
        }
}

function getExperimentAsObject($expID) 
{
    return new CurrExperiment($expID);
}


function getAccessibleExperimentsAsObjects($userid, $isTestbedMaintainer)
{
    Db::getInstance()->selectDB("wsn_info");
    $experiments = Db::getInstance()->getCurrentRunningExperimentIDsOfUser($userid, $isTestbedMaintainer);
    $publicExp = Db::getInstance()->getCurrentRunningExperimentIDsPubliclyVisible();
    
    foreach ($publicExp as $expid) {
            if(!in_array($expid,$experiments)) {
            array_push($experiments, $expid);
            }
    }
    
    $expArray = array();
    
    foreach ($experiments as $expid) {
        array_push($expArray, new CurrExperiment($expid));
    }
    
    return $expArray;
}

function displayExperimentBox($exp, $withAbortOption, $password, $isTestbedMaintainer) 
{
    echo "<table style='border: 1px solid black'>\n";
    echo "<colgroup>\n";
    echo "<col width='230'></col>\n";
    echo "<col width='500'></col>\n";
    echo "</colgroup>\n";
    $encrypted = quick_encrypt($exp->expID, $password);
    if($_SERVER['personUniqueID'] == $exp->userGroup) {
        echo "<tr>";
        echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'><a href='expObservIndex.php?display_id=" . $encrypted . "'>" . $exp->expID . "</a></td>";
        echo "</tr>";
    }
    else {
        echo "<tr>";
        echo "<td><strong>Experiment ID (encrypted):</strong></td>" . "<td bgcolor='#F2F2F2'><a href='expObservIndex.php?display_id=" . $encrypted . "'>" . $encrypted . "</a></td>";
        echo "</tr>";    
    }
    echo "<tr>";
    echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$exp->userGroup." (".$exp->expUserEmail.")</td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td><strong>Name:       </strong></td>"; 
    if(strlen($exp->expName)==0) {
        echo "<td bgcolor='#F2F2F2'><i>no name supplied</i></td>";
    }
    else {
        echo "<td bgcolor='#F2F2F2'>" . $exp->expName . "</td>";
    }
    echo "</tr>";
    echo "<tr>";
    echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
    if(strlen($exp->expDescription)==0) {
        echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>";
    }
    else {
        echo "<td bgcolor='#F2F2F2'>" . $exp->expDescription . "</td>";
    }
    echo "</tr>";
    echo "<tr>";
    echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $exp->startTime . "</td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $exp->endTime . "</td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td><strong>Runs: </strong></td><td bgcolor='#F2F2F2'>" . $exp->expRuns . "</td>";
    echo "</tr>";
    
    if(strcmp($exp->userGroup, ($_SERVER['personUniqueID'])==0 || $isTestbedMaintainer) && $withAbortOption) {
	    echo "<tr>";
	    echo "<td>";
	    echo "</td>";
	    echo "<td>";
	    echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
	    echo "<td></td>\n";
	    echo "<td width='50%' align='left'><form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='endExperiment' action='expObservInspectConfiguration.php' method='POST'>\n";
        echo "<input type='submit' id='inspectExperiment' name='inspectExperiment' value='Inspect Configuration'></input>\n";
        echo "<input name='exp_id' type='hidden' value='".$exp->expID."'></input></form></td>\n";
        echo "<td width='50%' align='right'><form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='endExperiment' action='' method='POST'>\n";
	    echo "<input type='submit' id='endExperiment' name='endExperiment' value='End Experiment, Save Results'></input>\n";
        echo "<input name='expid' type='hidden' value='".$exp->expID."'></input></form></td>\n";
	    echo "</tr></table>\n";
	    echo "</td>";
	    echo "</tr>";
    }
    
    echo "</table>\n";
    echo "<br/>\n";
}

function displaySmallExperimentBox($exp, $password) 
{
    echo "<table style='border: 1px solid black'>\n";
    echo "<colgroup>\n";
    echo "<col width='230'></col>\n";
    echo "<col width='500'></col>\n";
    echo "</colgroup>\n";
    $encrypted = quick_encrypt($exp->expID, $password);
    if($_SERVER['personUniqueID'] == $exp->userGroup) {
        echo "<tr>";
        echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'><a href='expObservIndex.php?display_id=" . urlencode($encrypted) . "'>" . $exp->expID . "</a></td>";
        echo "</tr>";
    }
    else {
        echo "<tr>";
        echo "<td><strong>Experiment ID (encrypted):</strong></td>" . "<td bgcolor='#F2F2F2'><a href='expObservIndex.php?display_id=" . urlencode($encrypted) . "'>" . $encrypted . "</a></td>";
        echo "</tr>";    
    }
    echo "<tr>";
    echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$exp->userGroup." (".$exp->expUserEmail.")</td>";
    echo "</tr>";
    echo "<tr>";
    echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . $exp->expName . "</td>";
    echo "</tr>";
    echo "</table>\n";
    echo "<br/>\n";
}


function getDefinedTupleForNode($node_urn, $templatedNodesImagesArray) {
   foreach($templatedNodesImagesArray as $tuple){
        if($tuple['node_urn']==$node_urn) {
            return $tuple;
        }       
   }
   return NULL;
}

function quick_encrypt($string, $key) {
    $result = '';
    for($i=0; $i<strlen($string); $i++) {
            $char = substr($string, $i, 1);
            $keychar = substr($key, ($i % strlen($key))-1, 1);
            $char = chr(ord($char)+ord($keychar));
            $result.=$char;
    }      
    return base64_encode($result);
}

function quick_decrypt($string, $key) {
    $result = '';
    $string = base64_decode($string);

    for($i=0; $i<strlen($string); $i++) {
            $char = substr($string, $i, 1);
            $keychar = substr($key, ($i % strlen($key))-1, 1);
            $char = chr(ord($char)-ord($keychar));
            $result.=$char;
    }
    return $result;
}

?>
