<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
 * Copyright (C) 2004-2005 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: application.inc,v 1.34 2007/10/18 09:00:43 vlry Exp $
 */
 
/**
 * Include (require) this file at the beginning of your PHP file
 * in order to load the complete library.
 *
 * <b>Typical Usage</b>
 * <pre>
 *   require_once("include/application.inc");
 * </pre>
 *
 * @version $Revision: 1.34 $
 *
 * @package Library 
 */ 

//
// error handling
//
//error_reporting(E_ALL);
error_reporting(E_ALL & ~E_NOTICE);
ini_set('log_errors', true);
 
// include SNAportal config
require_once("config/sna-portal.config");

// boostrap logging 
require_once('include/Logger.class.inc');
$logger= Logger::getInstance();
$logger->setLevel( LOGGER_LOGLEVEL ); // from config
$logger->setLogfile( LOGGER_FILENAME ); // from config

// bootstrap error handling
require_once("include/ErrorHandling.class.inc");
if (strpos('5.', phpversion()) === 0) {
    set_error_handler(array('ErrorHandling','userErrorHandler'),E_USER_ERROR);
}
else {
    set_error_handler(array('ErrorHandling','userErrorHandler'));
}
// include constants here (!Always include before class definitions!)
require_once("include/constants.inc");

// include all classes here
require_once("include/pre-php-4.2.inc");
require_once("include/Adapting.class.inc");
require_once("include/I18N.class.inc");
require_once("include/Formatting.class.inc");
require_once("include/Session.class.inc");
require_once("include/MySQLConnection.class.inc");
require_once("include/User.class.inc");
require_once("include/Role.class.inc");
require_once("include/AttributeType.class.inc");
require_once("include/Subscription.class.inc");
require_once("include/Administrator.class.inc");
require_once("include/UserPrivilege.class.inc");
require_once("include/Messaging.class.inc");
require_once("include/PHPMailer.class.inc");
require_once("include/Invitation.class.inc"); 
require_once("include/Event.class.inc");
require_once("include/Role.class.inc");
require_once("include/Action.php");
// bootstrap DB connection
MySQLConnection::createConnection();

?>
