<?PHP
/*
* SNA-Portal mediates between one or more Authentication and Authorisation
* Infrastructures and non-AAI-enabled roles.
* Copyright (C) 2003 Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
* Copyright (C) 2004 SWITCH (http://www.switch.ch)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
* $Id: WebCTVista.inc,v 1.5 2006/09/07 15:06:30 vlry Exp $
*/
/**
 * WebCT Vista
 *
 * @version $Revision: 1.5 $
 * @author Valery Tschopp - SWITCH
 *
 * @package WebCTAPI
 */

/**
* Static class for static and generic functions.
*
* @static
*/
class WebCTVista {
        
    /**
    * Generates a Message Authentication Code as specified by WebCT Vista.
    * The MAC is a MD5 hash generated by the checksum of the data string and the
    * shared secret of WebCT.
    *
    * @param string $data The data string to encode.
    * @param string $secret The WebCT Vista shared secret.
    * @return string The hex MD5 MAC (32 uppercase chars).
    *
    * @static
    */
    function generate_MAC( $data, $secret ) {
        //XXX
        //print "generate_MAC: $data $secret\n";
        // compute the ascii checksum of the data string
        $checksum= 0;
        for ( $i= 0; $i < strlen( $data ); $i++) {
            $checksum += ord( $data[$i] );
        }
        // concat checksum and secret
        $mac_data= "$checksum$secret";
        //print "generate_MAC: $mac_data\n";
        // get hex MD5
        $mac= strtoupper( md5( $mac_data ));
        return $mac;
    }
    
    /**
     * Static class
     */
    function WebCTVista() {
        trigger_error("Static class cannot be instanciate", E_USER_ERROR);
        return;
    }
}

?>
