#!/bin/bash

##########################################################

function readconf() {
    while read line; do
        # skip comments
        [[ ${line:0:1} == "#" ]] && continue
        # skip empty lines
        [[ -z "$line" ]] && continue
        line=`echo $line | awk -F "#" '{print $1}'`
        # echo line=$line
        key=${line//=*}
        value=${line//*=}
        key=$(echo "$key" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        value=$(echo "$value" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        # echo key=$key
        # echo value=$value
        export $key="$value" >/dev/null 2&>1
    done < "$CONFIG"
}

#########################################################

# read in the configuration file

CONFIG=/etc/SNA.conf

readconf

echo "going to config file"

cd /opt/sna-portal-1.0.5/config

echo "SUPPORT_EMAIL: " $SUPPORT_EMAIL
echo "SUPPORT_URL: "   $SUPPORT_URL
echo "SNA_MYSQL_PASS: " $SNA_MYSQL_PASS
echo "SNA_GUI_URL: " $SNA_GUI_URL
echo "AAI_PORTAL_SMTP: " $AAI_PORTAL_SMTP

cp /opt/sna-portal-1.0.5/config/sna-portal.config.distrib /opt/sna-portal-1.0.5/config/sna-portal.config

sed -i 's|'ENTER_SUPPORT_EMAIL_HERE'|'$SUPPORT_EMAIL'|g' /opt/sna-portal-1.0.5/config/sna-portal.config
sed -i 's|'ENTER_SUPPORT_URL_HERE'|'$SUPPORT_URL'|g' /opt/sna-portal-1.0.5/config/sna-portal.config
sed -i 's|'ENTER_MYSQL_PASS_HERE'|'$SNA_MYSQL_PASS'|g' /opt/sna-portal-1.0.5/config/sna-portal.config
sed -i 's|'ENTER_PORTAL_BASE_URL_HERE'|'$SNA_GUI_URL'|g' /opt/sna-portal-1.0.5/config/sna-portal.config
sed -i 's|'ENTER_AAI_PORTAL_SMTP_HERE'|'$AAI_PORTAL_SMTP'|g' /opt/sna-portal-1.0.5/config/sna-portal.config

touch /etc/apache2/sites-available/sna-portal 

>/etc/apache2/sites-available/sna-portal 

cat > /etc/apache2/sites-available/sna-portal << EOF

Alias /sna-portal  "/opt/sna-portal-1.0.5/web"
<Directory "/opt/sna-portal-1.0.5/web">
DirectoryIndex index.php
AllowOverride All
Order allow,deny
Allow from all
</Directory>

EOF

cd 

echo "######### enabling webservices           ###########"
cp -r /opt/sna-portal-1.0.5/webservices /var/www/
chown -R www-data:www-data /var/www/webservices

a2ensite sna-portal
/etc/init.d/apache2 reload

echo "######### CONFIGURATION OF SNAA TOOL DONE ##########"
