<?php 

/* ***************************************************************** */
/*                        functions                                  */
/* ***************************************************************** */



function validate_input(&$input_errors) {
    $valid= true;
    $title= $_REQUEST["action_name"];
    $title= trim($title);
    if ( empty($title) ) {
        $valid = false;
        $input_errors["action_name"] = "Please enter a non-empty action name.";    
    }
	if (strpos($title," ")!=null){
        $valid = false;
        $input_errors["action_name"] = "Please don't use a empty space in the action name.";    
	}
    
    $url= $_REQUEST["action_title"];    
    $url= trim($url);
    if ( empty($url) ) {
        $valid= false;
        $input_errors["action_title"] = "Please enter a non-empty action title.";    
    }

	return $valid;
}

/**
 * Creates a new action from the values provided
 *   in the $_REQUEST object 
 *
 */
function createAction(&$admin) {  

    $provider_id= $admin->getID();
    $action_name= $_REQUEST["action_name"];
    $action_name= trim($action_name);

    $action_title= $_REQUEST["action_title"];
    $action_title= trim($action_title);
	
    $action_description= $_REQUEST["action_description"];
    $action_description= trim($action_description);
	
    $action=& Action::create($provider_id, $action_name, $action_title, $action_description );

    return $action;
}

// bootstrap application
//
require_once("include/application.inc");

//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin) ) {
   ErrorHandling::fatalErrorAndExit("Current user is not priviledged to enter this page"); 
}


Session::init($admin);
	
// process save operation 
//
$input_errors= array(); 
if ( isset($_REQUEST['do_save']) ) {  
	
  if (validate_input(&$input_errors)) {
     $action =& createAction(&$admin);     
     header("Location: " . PORTAL_BASE_URL . "/admin/edit-action.php?aid=" . $action->getID());
     exit;
  }
}

// process REQUEST parameters
$req_action_name= "";
if (isset($_REQUEST['action_name'])) {
    $req_action_name= trim($_REQUEST['action_name']);
}
$req_action_title= "";
if (isset($_REQUEST['action_title'])) {
    $req_action_title= trim($_REQUEST['action_title']);
}
$req_action_description= "";
if (isset($_REQUEST['action_description'])) {
    $req_action_description= trim($_REQUEST['action_description']);
}



/* ****************************************************************** */
/*                     page content                                   */
/* ****************************************************************** */
include("include/adminHeader.inc");
?>

<?php
/* ****************************************************************** */
/*                     client side java script                        */
/* ****************************************************************** */
?>

<script>
function reloadForm() {
    document.newAction.submit();
}

</script>

<h1>New Action</h1>

  To create a new action enter the form below and click on
  <span class="button-reference">Save</span>. Fields marked with
  <img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">
  must be filled in.
  <p/>
    
  <form name="newAction" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">

  <table width="90%" border="0" cellspacing="0" class="form-table">


    <!-- ************* Action Name ************************** -->
<tr>
<td width="30%" valign="top" class="form-label form-first">
Action Name
</td>
<td width="70%" valign="top" class="form-entry">
<input type="text" name="action_name" value="<?= $req_action_name ?>" size="40"/>
<img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">

<?php if (isset($input_errors["action_name"])): ?>
<br/><span class="error-message"><?= $input_errors["action_name"] ?></span>
<?php endif; ?>

</td>
</tr>

    <!-- ************* Action Title    ************************** -->
    <tr>
      <td width="30%" valign="top" class="form-label">
      Action Title
      </td>
      <td width="70%" valign="top" class="form-entry">
       <input type="text" name="action_title" value="<?= $req_action_title ?>" size="40"/>
      <img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">
      
      <?php if (isset($input_errors["action_title"])): ?>
      <br/><span class="error-message"><?= $input_errors["action_title"] ?></span>
      <?php endif; ?>
      
      </td>
    </tr>

    <!-- ************* Action Description    ********************* -->
    <tr>
      <td width="30%" valign="top" class="form-label">
      Action Description
      </td>
      <td width="70%" valign="top" class="form-entry">
      <textarea name="action_description" cols="40" rows="5"><?= $req_action_description ?></textarea>
      </td>
    </tr>

    <!-- ************* Control Buttons ************************** -->    
    <tr>
      <td width="100%" valign="top" align="center" class="form-control" colspan="2">
      <input type="submit" name="do_save" value="Save" />
      </td>    
    </tr>
  
  </table>
  </form>

  

<?php 
// include common page footer
//
include("include/adminFooter.inc");
?>
