<?php

	function validate_input(&$input_errors) {
		$valid= true;
		$name= $_REQUEST["action_name"];
		$name= trim($name);
		if ( empty($name) ) {
			$valid = false;
			$input_errors["action_name"] = "Please enter a non-empty action name.";    
		}
		if (strpos($name," ")!=null){
			$valid = false;
			$input_errors["action_name"] = "Please don't use a empty space in the action name.";    
		}
		
		$title= $_REQUEST["action_title"];    
		$title= trim($title);
		if ( empty($title) ) {
			$valid= false;
			$input_errors["action_title"] = "Please enter a non-empty action title.";    
		}
		
		return $valid;
	}
	
	
	/**
	 * Updates a action with current values in the

	 */
	function updateAction(&$act) {
		
		$act->setName(trim($_REQUEST["action_name"]));
		$act->setTitle(trim($_REQUEST["action_title"]));
		$act->setDescription(trim($_REQUEST["action_description"]));
		
		$act->persist();
	}
	

	

	
	/* **************************************************************** */
	/**
	 * Ensures that request parameters are valid. If the request is invalid
	 * an error message is displayed and the page aborts with a fatal
	 * error.
	 *
	 * @access private
	 */
	function ensure_request_parameters_valid() {
		if (! isset($_REQUEST["aid"])) {
			ErrorHandling::fatalErrorAndExit("request parameter 'aid' is missing"); 
		}
		
		$action = $_REQUEST["aid"];
		if (! is_numeric($action) || $action < 0) {
			ErrorHandling::fatalErrorAndExit("illegal value '$action' for request parameter 'aid'. Aborting.");    
		}
	}
	
	// bootstrap application
	//
	require_once("include/application.inc");
	
	ensure_request_parameters_valid();
	
	//
	// resume the current session and make sure we have a valid session
	//
	Session::ensureAdminSessionValid();
	
	$uid= Session::getUID();
	$admin=& Administrator::reconstituteByUid($uid);
	if (is_null($admin)) {
		ErrorHandling::fatalErrorAndExit("Current user is not priviledged to enter this page"); 
	}
	Session::init($admin);
	
	$aid= $_REQUEST["aid"];
	$action =& Action::reconstituteById($aid);

	if (is_null($action)) {
		ErrorHandling::fatalErrorAndExit("Illegal action id ($aid) submitted");
	}
	//
	// process save operation
	//
	$input_errors = array();
	if (isset($_REQUEST['do_save'])) {
		if (validate_input(&$input_errors,&$action)) {     
			updateAction(&$action); 
		}
	}

	
	/* ****************************************************************** */
	/*                     page content                                   */
	/* ****************************************************************** */
	include("include/adminHeader.inc");
	
	?>
<script>
<!--
function delete_action(aid) {
	if (! confirm("Do you really want to delete this action ?")) return;
	window.open('delete-action.php?aid=' + aid + '&url=', '_self');
}

function reloadForm() {
	document.editaction.action.value= "change_adapter";
	document.editaction.submit();
}
// -->
</script>


<h1>Edit Action</h1>

Fields marked with
<img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">
must be filled in.
<p/>


<form name="editaction" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">

<input type="hidden" name="aid" value="<?= $aid ?>" />
<input type="hidden" name="action" value="" />

<table width="90%" border="0" cellspacing="0" class="form-table">


<tr>
<td width="30%" valign="top" class="form-label form-first">
Date Created
</td>
<td width="70%" valign="top" class="form-entry form-first">
<?= Formatting::formatMysqlDate($action->getDateCreated(),true) ?>
</td>
</tr>

<tr>
<td width="30%" valign="top" class="form-label">
Action Name
</td>
<td width="70%" valign="top" class="form-entry">
<input type="text" name="action_name" value="<?= $action->getName() ?>" size="40" />
<img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">
<?php if ( isset( $input_errors["action_name"] ) ): ?>
<br/><span class="error-message"><?= $input_errors["action_name"] ?></span>
<?php endif; ?>
</td>
</tr>

<tr>
<td width="30%" valign="top" class="form-label">
Action Title
</td>
<td width="70%" valign="top" class="form-entry">
<input type="text" name="action_title" value="<?= $action->getTitle() ?>" size="40"/>
<img src="<?= PORTAL_BASE_URL ?>/lookandfeel/current/mandatory.gif">
<?php if ( isset($input_errors["action_title"]) ): ?>
<br/><span class="error-message"><?= $input_errors["action_title"] ?></span>
<?php endif; ?>
</td>
</tr>

<tr>
<td width="30%" valign="top" class="form-label">
Action Description
</td>
<td width="70%" valign="top" class="form-entry">
<textarea name="action_description" cols="40" rows="5"><?= $action->getDescription() ?></textarea>
</td>
</tr>

<tr>
<td width="100%" valign="top" align="center" class="form-control" colspan="2">
<input type="submit" name="do_save" value="Save" />
</td>    
</tr>

</table>
</form>



<?php
	// include common page footer
	//
	include("include/adminFooter.inc");
	?>
