<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2005 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: list-events.php,v 1.9 2007/10/08 14:42:01 vlry Exp $
 */

/**
* Displays a list of all available roles.
* 
* @version $Revision: 1.9 $
* @package AdminPortal
*/

// bootstrap application
//
require_once("include/application.inc");

//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin) or !$admin->isPortalAdministrator()) {
   ErrorHandling::fatalErrorAndExit("current user is not priviledged to enter this page"); 
}
Session::init($admin);

// search params
$search_event_level= EVENT_LEVEL_ALL; // all level
if (Session::exists('event_search_level')) {
    $search_event_level= Session::get('event_search_level');
}
if (isset($_REQUEST['event_search_level'])) {
    $search_event_level= $_REQUEST['event_search_level'];
    Session::set('event_search_level', $search_event_level);
}

$search_event_type= EVENT_TYPE_ALL; // all type 
if (Session::exists('event_search_type')) {
    $search_event_type= Session::get('event_search_type');
}
if (isset($_REQUEST['event_search_type'])) {
    $search_event_type= $_REQUEST['event_search_type'];
    Session::set('event_search_type', $search_event_type);
}
$search_event_message= null; // all messages
if (Session::exists('event_search_message')) {
    $search_event_message= Session::get('event_search_message');
}
if (isset($_REQUEST['event_search_message'])) {
    $search_event_message= $_REQUEST['event_search_message'];
    Session::set('event_search_message', $search_event_message);
}
//XXX
//print "XXX:search_event_level= $search_event_level<br>";
//print "XXX:search_event_type= $search_event_type<br>";
//print "XXX:search_event_message= $search_event_message<br>";

$is_search= ($search_event_level != EVENT_LEVEL_ALL or 
             $search_event_type != EVENT_TYPE_ALL or 
             !empty($search_event_message));

// orderby in request?
$orderby= 'event_date'; // default sorting
if (Session::exists('event_order_by')) {
    $orderby= Session::get('event_order_by');
}
if (isset($_REQUEST['order_by'])) {
    $orderby= $_REQUEST['order_by'];
    Session::set('event_order_by', $orderby);
}
//XXX
//print "XXX:orderby= $orderby<br>";

// limit offset, count
$limit_offset= 0;
if (isset($_REQUEST['limit_offset'])) {
    $limit_offset= $_REQUEST['limit_offset'];
}
$limit_count= 100; // default 100 events/page
if (Session::exists('limit_count')) {
    $limit_count= Session::get('limit_count');
}
if (isset($_REQUEST['limit_count'])) {
    $limit_count= $_REQUEST['limit_count'];
    Session::set('limit_count', $limit_count);
}
//XXX
//print "limit_offset: $limit_offset<br>";
//print "limit_count: $limit_count<br>";

// purge events older
if (isset($_REQUEST['action']) and $_REQUEST['action'] == 'do_purge_events') {
    if (isset($_REQUEST['event_purge_older']) and !empty($_REQUEST['event_purge_older'])) {
        $event_purge_older= $_REQUEST['event_purge_older'];
        //XXX print "XXX: event_purge_older: $event_purge_older<br>";
        Event::storeSystemEvent("Delete events older than $event_purge_older days", 
                                 EVENT_LEVEL_WARNING);
        Event::deleteEventsOlder($event_purge_older);
    }
}

$n_events= Event::getEventsCount($search_event_level,$search_event_type,$search_event_message);
if ($is_search) {
    $total_events= Event::getEventsCount();
}
$n_pages= ceil( $n_events / $limit_count );
$page_n= ($limit_offset / $limit_count ) + 1;


/* ****************************************************************** */
/*                     page content                                   */
/* ****************************************************************** */
include("include/adminHeader.inc");

// import function to print the HTML page control <<|1|2|...|5|6|7|8|9|..|20|21|>>
include("include/adminPagesControl.inc");

?>

<script language="JavaScript">
<!--
function orderby(attr_name) {
    document.form_controller.order_by.value= attr_name;
    document.form_controller.submit();
}

function change_limit_count() {
    var lcount= parseInt(document.form_controller.limit_count_list.value);
    document.form_controller.limit_count.value= lcount;
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function goto_page( page_n ) {
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= lcount * ( page_n - 1 );
    document.form_controller.submit();
}

function prev_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset - lcount;
    document.form_controller.submit();
}
function next_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset + lcount;
    document.form_controller.submit();
}

function do_search() {
    document.form_controller.action.value= "do_search";
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function clear_search() {
    document.form_controller.event_search_level.value= -1;
    document.form_controller.event_search_type.value= -1;
    document.form_controller.event_search_message.value= "";
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function do_purge_events() {
    var days= document.form_controller.event_purge_older.value;
    if (confirm("Do you really want to delete all events older than " + days + " days?")) {
        document.form_controller.action.value= "do_purge_events";
        document.form_controller.limit_offset.value= 0;
        document.form_controller.submit();
    }
}

// -->
</script>

<h1>Events Viewer
<?php if ($is_search): ?>
 (Filtered Result)
<?php endif; ?>
</h1>
  
<form name="form_controller" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
  <input type="hidden" name="action" value="do_search" />
  <input type="hidden" name="order_by" value="<?= $orderby ?>" />
  <input type="hidden" name="limit_offset" value="<?= $limit_offset ?>" />
  <input type="hidden" name="limit_count" value="<?= $limit_count ?>" />
<!-- SEARCH FUNCTION BEGIN -->
Show events level <select name="event_search_level">
<?php
    $search_levels= array(-1 => 'All', 0 => 'INFO', 1 => 'WARNING', 2 => 'ERROR');
    foreach($search_levels as $level => $name) {
        $selected= "";
        if ($level == $search_event_level) { $selected= "selected ";}
        print "<option value=\"$level\" $selected>$name";
    }
?>
  </select>
  category <select name="event_search_type">
<?php
    $search_types= array(-1 => 'All', 0 => 'SYSTEM', 1 => 'AUTH', 2 => 'ACCESS', 
                          3 => 'USER', 4 => 'RESOURCE', 5 => 'SUBSCRIPTION' );
    foreach($search_types as $type => $name) {
        $selected= "";
        if ($type == $search_event_type) { $selected= "selected ";}
        print "<option value=\"$type\" $selected>$name";
    }
?>
  </select>
  containing <input type="text" name="event_search_message" value="<?= $search_event_message ?>" />

  <input type="button" value="Search" onClick="do_search()" />
  <input type="button" value="All" onClick="clear_search()"/>
<!-- SEARCH FUNCTION END -->
<br/>
<!-- PAGE COUNT BEGIN -->
<?= $n_events ?> <?php if ($is_search) { print "(of " . $total_events . ") "; } ?>
events (<select name="limit_count_list" onChange="change_limit_count()">
<?php
    // drop down list 10, 25, 50, 100, 200
    $limit_counts= array( 10, 25, 50, 100, 200 );
    foreach( $limit_counts as $count ) {
        $selected= "";
        if ($count == $limit_count) $selected= "selected ";
        print "<option value=\"$count\" $selected>$count";
    }
?>
</select>
events/page on <?= $n_pages ?> pages)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<!-- PAGE COUNT END -->
<!-- EVENTS PURGE BEGIN -->
Purge events older than <select name="event_purge_older">
    <option value="60" selected >2 months
    <option value="30" >1 month
    <option value="7" >1 week
</select>
<input type="button" value="Purge" onClick="do_purge_events()"/>
<!-- EVENTS PURGE END -->
</form>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    print_pages_control($n_pages, $page_n);
 }
 ?>
 <p/>
  
  <table width="100%" border="0" cellspacing="0" class="data-table">

    <tr>
      <th class="data" width="15%"><a href="javascript:orderby('event_date')" title="Sort by Event Date">
      <?php if ($orderby == 'event_date') print "<i>Date</i>"; else print "Date"; ?>
      </a>
      </th>
      <th class="data" width="5%"><a href="javascript:orderby('event_level')" title="Sort by Event Level">
      <?php if ($orderby == 'event_level') print "<i>Level</i>"; else print "Level"; ?>
      </a>
      </th>
      <th class="data" width="5%"><a href="javascript:orderby('event_type')" title="Sort by Event Category">
      <?php if ($orderby == 'event_type') print "<i>Category</i>"; else print "Category"; ?>
      </a>
      </th>
       <th class="data last">Messages</th>
    </tr>  

<?php
 $events= Event::getEvents($search_event_level, $search_event_type, $search_event_message,
                           $orderby, $limit_offset, $limit_count);
 $i = 0;
 foreach($events as $event):
    $event_level= $event['event_level'];
    $event_type= $event['event_type'];
    $event_date= $event['event_date'];
    $event_message= $event['event_message'];
    $style= ($i++ % 2 == 0) ? "data-even" : "data-odd";
    // formating
    $date= Formatting::formatMySQLDate($event_date,true,true);
    switch ($event_level) {
        case 0: $level= "INFO"; break;
        case 1: $level= "<font color=\"orange\">WARNING</font>"; break;
        case 2: $level= "<font color=\"red\">ERROR</font>"; break;
        default: $level= $event_level;
    }
    switch ($event_type) {
        case 0: $type= "SYSTEM"; break;
        case 1: $type= "AUTH"; break;
        case 2: $type= "ACCESS"; break;
        case 3: $type= "USER"; break;
        case 4: $type= "RESOURCE"; break;
        case 5: $type= "SUBSCRIPTION"; break;
        default: $type= $event_type;
    }
  ?>

      <tr>
        <td valign="top" class="<?= $style ?>">
           <?= $date ?>
        </td>
        <td valign="top" class="<?= $style ?>">
           <?= $level ?>
        </td>
        <td valign="top" class="<?= $style ?>">
           <?= $type ?>
        </td>
        <td valign="top" class="<?= $style ?> last">
            <?= $event_message ?>
        </td>
      </tr>   

   <?php endforeach; ?>


   </table>

 <p/>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    print_pages_control($n_pages, $page_n);
 }
 ?>
 <p/>



<?php
// include common page footer
//
include("include/adminFooter.inc");
?>
