<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2005 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: list-invitations.php,v 1.9 2005/11/01 16:28:04 vlry Exp $
 */

/**
* Displays a list of all invitations send for a role.
*
* 
* @version $Revision: 1.9 $
* @package AdminPortal
*/

function handle_do_delete() {
    foreach ($_REQUEST as $key => $value) {
        if (ereg("^invit-([0-9a-fA-F]+)-([0-9]+)$", $key, $regs)) {
            $token= $regs[1];
            $rid= $regs[2];
            //XXX print "delete inviation $token, $rid<br>";
            Invitation::delete($token,$rid);
        }
    }
}

function handle_do_resend() {
    $resend_rid= null;
    $resend_emails= array();
    foreach ($_REQUEST as $key => $value) {
        if (ereg("^invit-([0-9a-fA-F]+)-([0-9]+)$", $key, $regs)) {
            $token= $regs[1];
            $rid= $regs[2];
            // at least one resend
            $resend_rid= $rid;
            // get email 
            $email= Invitation::getEmail($token,$rid);
            if (!is_null($email)) {
                $resend_emails[]= $email;
            }
            
        }
    }
    if (!is_null($resend_rid) and !empty($resend_emails)) {
        $inv_emails= implode(',', $resend_emails);
        $location= "new-invitation.php?rid=$resend_rid&invitation_emails=$inv_emails";
        header("Location: $location");
        exit();
    }
}
//
// bootstrap application
//
require_once("include/application.inc");

//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin)) {
   ErrorHandling::fatalErrorAndExit("Current user is not priviledged to enter this page"); 
}
Session::init($admin);

//
// process request param
//
if (! isset($_REQUEST["rid"])) {
    ErrorHandling::fatalErrorAndExit("Request parameter 'rid' is missing.");
}
$rid= $_REQUEST["rid"];
$role=& Role::reconstituteById($rid);
if (is_null($role)) {
  ErrorHandling::fatalErrorAndExit("Invalid role id ($rid) submitted.");
}

// 
// process action request
//
if (isset($_REQUEST['action'])) {
    if ($_REQUEST['action'] == 'do_delete') {
        handle_do_delete();
    }
    else if ($_REQUEST['action'] == 'do_resend') {
        handle_do_resend();
    }


}

// orderby in request?
$orderby= 'email'; // default sorting
if (Session::exists('invitation_order_by')) {
    $orderby= Session::get('invitation_order_by');
}
if (isset($_REQUEST['order_by'])) {
    $orderby= $_REQUEST['order_by'];
    Session::set('invitation_order_by', $orderby);
}
//XXX
//print "orderby: $orderby<br>";

// limit offset, count
$limit_offset= 0;
if (isset($_REQUEST['limit_offset'])) {
    $limit_offset= $_REQUEST['limit_offset'];
}
$limit_count= 100; // default 100 invitations/page
if (Session::exists('limit_count')) {
    $limit_count= Session::get('limit_count');
}
if (isset($_REQUEST['limit_count'])) {
    $limit_count= $_REQUEST['limit_count'];
    Session::set('limit_count', $limit_count);
}
//XXX
//print "limit_offset: $limit_offset<br>";
//print "limit_count: $limit_count<br>";

$n_invitations= Invitation::getInvitationsCount($rid);
$n_pages= ceil( $n_invitations / $limit_count );
$page_n= ($limit_offset / $limit_count ) + 1;


/* ****************************************************************** */
/*                     page content                                   */
/* ****************************************************************** */
include("include/adminHeader.inc");
?>

<script language="JavaScript">
<!--
function resend_invitation(id) {
    select_invitation(id);
    resend_selected();
}

function resend_selected() {
    if (num_selected() == 0) {
        alert("Please select at least one invitation first.")
        return;
    }
    document.form_controller.action.value= "do_resend";
    document.form_controller.submit();
}

function delete_invitation(id) {
    if (confirm("Are you sure you want to delete this invitation?")) {
        select_invitation(id);
        document.form_controller.action.value= "do_delete";
        document.form_controller.submit();
    }

}

function delete_selected() {
    var n_invits= num_selected();
    if (n_invits == 0) {
        alert("Please select at least one invitation first.")
        return;
    }
    if (confirm("Are you sure you want to delete the selected invitations?")) {
        if (confirm("Really sure? Delete " + n_invits + " invitations?")) {
            document.form_controller.action.value= "do_delete";
            document.form_controller.submit();
        }
    }
}



function select_invitation(id) {
  var sub_id= "invit-" + id;
  document.form_controller[sub_id].checked= true;
}

function select_all() {
  for(i=0; i < document.form_controller.elements.length;i++) {
    var el = document.form_controller.elements[i];
    if (el.name.indexOf("invit-") == 0) {
      el.checked= true; 
    }
  }
}

function unselect_all() {
  for(i=0; i < document.form_controller.elements.length;i++) {
    var el = document.form_controller.elements[i];
    if (el.name.indexOf("invit-") == 0) {
      el.checked= false;
    }
  }
}

function num_selected() {
    var n= 0;
    for(i=0; i < document.form_controller.elements.length;i++) {
        var el= document.form_controller.elements[i];
        if (el.name.indexOf("invit-") == 0) {
            if (el.checked) { n++; }
        }
    }
    return n;
}

function orderby(attr_name) {
    document.form_controller.order_by.value= attr_name;
    document.form_controller.submit();
}

function change_limit_count() {
    var lcount= parseInt(document.form_controller.limit_count_list.value);
    document.form_controller.limit_count.value= lcount;
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}


function goto_page( page_n ) {
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= lcount * ( page_n - 1 );
    document.form_controller.submit();
}

function prev_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset - lcount;
    document.form_controller.submit();
}
function next_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset + lcount;
    document.form_controller.submit();
}
// -->
</script>


  <h1>Unused invitations for Role: <?= $role->getTitle() ?> (<?= $role->getRoleKey() ?>)</h1>
 
<?php if ($n_invitations == 0): ?>

  <table width="95%" border="0" cellspacing="0" class="data-table">
    <!-- HEADERS -->
    <tr>
      <th class="data">&nbsp;</th>
      <th class="data">Receipient Email</a></th>
      <th class="data">Sent Date</a></th>
      <th class="data">Token</a></th>
      <th class="data last">Actions</th>
    </tr>  
    <tr>
        <td class="data-even last" colspan="5">There is no unused invitation for this role.</td>
    </tr>
  </table>

<?php else: ?>
  
<form name="form_controller" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
  <input type="hidden" name="rid" value="<?= $rid ?>" />
  <input type="hidden" name="action" value="unknown" />
  <input type="hidden" name="order_by" value="<?= $orderby ?>" />
  <input type="hidden" name="limit_offset" value="<?= $limit_offset ?>" />
  <input type="hidden" name="limit_count" value="<?= $limit_count ?>" />

<?= $n_invitations ?> invitations found (<select name="limit_count_list" onChange="change_limit_count()">
<?php
    // drop down list 10, 25, 50, 100, 200
    $limit_counts= array( 10, 25, 50, 100, 200 );
    foreach( $limit_counts as $count ) {
        $selected= "";
        if ($count == $limit_count) $selected= "selected ";
        print "<option value=\"$count\" $selected>$count";
    }
?>
</select> invitations/page on <?= $n_pages ?> pages)<br>


 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>

 <p/>
  
  <table width="95%" border="0" cellspacing="0" class="data-table">

    <!-- HEADERS -->
    <tr>
      <th class="data">&nbsp;</th>
      <th class="data"><a href="javascript:orderby('email')" title="Sort by Email">
      <?php if ($orderby == 'email') print "<i>Receipient Email</i>";
            else print "Receipient Email"; ?>
      </a></th>
      <th class="data"><a href="javascript:orderby('date_created')" title="Sort by Date">
      <?php if ($orderby == 'date_created') print "<i>Sent Date</i>";
            else print "Sent Date"; ?>
      </a></th>
      <th class="data"><a href="javascript:orderby('token')" title="Sort by Token">
      <?php if ($orderby == 'token') print "<i>Token</i>";
            else print "Token"; ?>
      </a></th>
      <th class="data last">Actions</th>
    </tr>  

   <?php
     $invitations_attrs= Invitation::getInvitationsAttributes($rid, $orderby, $limit_offset, $limit_count);
     $i = 0;
     foreach($invitations_attrs as $invitation_attrs):
        $user_email= $invitation_attrs['email'];
        $invit_date= $invitation_attrs['date_created'];
        $invit_token= $invitation_attrs['token'];
        $invit_id= "$invit_token-$rid";
        $style= ($i++ % 2 == 0) ? "data-even" : "data-odd";
       ?>
      
      <tr>
        <td class="<?= $style ?>">
         <input type="checkbox" name="invit-<?= $invit_id ?>" />
        </td>

        <td class="<?= $style ?>">
        <?= $user_email ?>
        </td>
        
        <td class="<?= $style ?>">
         <?= Formatting::formatMySQLDate( $invit_date, true ) ?>
        </td>

        <td class="<?= $style ?>">
         <tt><?= $invit_token ?></tt>
        </td>
        
        <td class="<?= $style ?> last">
        
          <a href="javascript:resend_invitation('<?= $invit_id ?>')">Resend</a>
          | <a href="javascript:delete_invitation('<?= $invit_id ?>')">Delete</a>
        </td>
      </tr>   

   <?php endforeach; ?>

    <tr>
      <td valign="top" class="data-odd last" colspan="5">
        <a href="javascript:select_all('form_pending_subs')">Select All</a> 
      | <a href="javascript:unselect_all('form_pending_subs')">Unselect All</a><br/>
      </td>
    </tr>  

    <tr>
      <td valign="top" class="form-control" colspan="5">
        <input type="button" name="do_resend" value="Resend Selected" onClick="javascript:resend_selected()"> 
        <input type="button" name="do_delete" value="Delete Selected" onClick="javascript:delete_selected()"> 
      </td>
    </tr>  

   </table>

</form>

 <p/>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>
 <p/>

<?php endif; ?>

<?php
// include common page footer
//
include("include/adminFooter.inc");
?>
