<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2006 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: list-my-roles.php,v 1.54 2006/09/28 13:02:05 vlry Exp $
 */


/**
* This page displays a list of all roles owned by the current
* administrator.
*
* @version $Revision: 1.54 $
* @package AdminPortal
*/


// bootstrap application
//
require_once("include/application.inc");

//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin)) {
   ErrorHandling::fatalErrorAndExit("current user is not priviledged to enter this page"); 
}
Session::init($admin);

// search params
$search_field= 'role_title'; // default: Title
$search_func= 2; // default: starts with
if (Session::exists('role_search_field')) {
    $search_field= Session::get('role_search_field');
}
if (isset($_REQUEST['role_search_field'])) {
    $search_field= $_REQUEST['role_search_field'];
    Session::set('role_search_field', $search_field);
}
if (Session::exists('role_search_func')) {
    $search_func= Session::get('role_search_func');
}
if (isset($_REQUEST['role_search_func'])) {
    $search_func= $_REQUEST['role_search_func'];
    Session::set('role_search_func', $search_func);
}
//XXX print "XXX:search_field= $search_field<br>";
//print "XXX:search_func= $search_func<br>";

$search_value= null;
$search_sql_value= null;
$is_search= false;
if (isset($_REQUEST['role_search_value']) and !empty($_REQUEST['role_search_value'])) {
    //XXX print "XXX:search_value= {$_REQUEST['role_search_value']}<br>";
    $search_value= trim($_REQUEST['role_search_value']);
    $is_search= true;
    switch ($search_func) {
        case 1: $search_sql_value= $search_value; break; // is
        case 2: $search_sql_value= "$search_value%"; break; // starts with
        case 3: $search_sql_value= "%$search_value"; break; // ends with
        case 4: $search_sql_value= "%$search_value%"; break; // contains
        default: $search_sql_value= "%$search_value%"; break;
    }
}


// limit offset, count
$limit_offset= 0;
if (isset($_REQUEST['limit_offset'])) {
    $limit_offset= $_REQUEST['limit_offset'];
}
$limit_count= 100; // default 100 roles/page
if (Session::exists('limit_count')) {
    $limit_count= Session::get('limit_count');
}
if (isset($_REQUEST['limit_count'])) {
    $limit_count= $_REQUEST['limit_count'];
    Session::set('limit_count', $limit_count);
}
//XXX print "limit_offset: $limit_offset<br>";
//print "limit_count: $limit_count<br>";

$n_roles= $admin->getMyRolesCount($search_field,$search_sql_value);
if ($is_search) {
    $total_roles= $admin->getMyRolesCount();
}
$n_pages= ceil( $n_roles / $limit_count );
$page_n= ($limit_offset / $limit_count ) + 1;

/* ****************************************************************** */
/*                     page content                                   */
/* ****************************************************************** */
include("include/adminHeader.inc");
?>

<?php if ( !Session::isSubscriptionAdministratorSession() ): ?>
<script language="JavaScript">
<!--
function delete_role(rid) {
  if (confirm("Do you really want to delete this role ?")) {
     select_role(rid);
     document.form_res_list.submit();
  }
}

function num_selected_roles() {
  var ret = 0;
  for(i=0; i < document.form_res_list.elements.length;i++) {
    var el = document.form_res_list.elements[i];
    if (el.name.substr(0,4) == "res-") {
      if (el.checked)ret++; 
    }
  }
  return ret;
}

function delete_selected_roles() {
  if (num_selected_roles() == 0) {
    alert("Please select at least one role first.")
  }
  else if (confirm("Do you really want to delete these roles ?")) {
    document.form_res_list.submit();
  }
  
}

function select_role(rid) {
    var res_id= "res-" + rid;
    for(i=0; i<document.form_res_list.elements.length; i++) {
        var elt= document.form_res_list.elements[i];
        if (elt.name == res_id) {
            elt.checked= true; 
        }
    }
}
function select_all_roles() {
  for(i=0; i < document.form_res_list.elements.length;i++) {
    var el = document.form_res_list.elements[i];
    if (el.name.substr(0,4) == "res-") {
      el.checked =  true; 
    }
  }
}

function unselect_all_roles() {
  for(i=0; i < document.form_res_list.elements.length;i++) {
    var el = document.form_res_list.elements[i];
    if (el.name.substr(0,4) == "res-") {
      el.checked =  false;
    }
  }
}

function change_limit_count() {
    var lcount= parseInt(document.form_controller.limit_count_list.value);
    document.form_controller.limit_count.value= lcount;
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}


function goto_page( page_n ) {
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= lcount * ( page_n - 1 );
    document.form_controller.submit();
}

function prev_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset - lcount;
    document.form_controller.submit();
}
function next_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset + lcount;
    document.form_controller.submit();
}

function do_search() {
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function clear_search() {
    document.form_controller.role_search_value.value= "";
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}
// -->
</script>
<?php endif; ?>


<h1>My Roles<?php if ($is_search): ?>
 (Filtered Result)
<?php endif; ?></h1>

<?php if ( $page_n <= 1): ?>

    <?php if ( !Session::isSubscriptionAdministratorSession()): ?>
        <p>Chose <span class="explained-link">Edit</span>
        to edit the role. Editing a role allow you to modify the adpater configuration,
        change the owner or add administrators for the role, as well as 
        edit mandatory attributes and create custom attributes. Chose <span class="explained-link">Admins</span> to access directly the Role Administrators management.
        You can delete the role with <span class="explained-link">Delete</span>.</p>
    <?php endif; ?>

<p>
Roles with pending subscription requests are marked with a red background.
It is recommended that you accept or reject pending subscription requests as
soon as possible. Click on <span class="explained-link">Subscriptions</span> 
to manage subscriptions to this role.
</p>

<p>
You can also send invitations for a role. An invitation allows to automatically
subscribe users to a role, without having to manage their subscription.
Click on <span class="explained-link">Invitations</span> 
to send new invitation for this role.
</p>
<?php endif; ?>

<form name="form_controller" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
  <input type="hidden" name="limit_offset" value="<?= $limit_offset ?>" />
  <input type="hidden" name="limit_count" value="<?= $limit_count ?>" />
<!-- SEARCH FUNCTION BEGIN -->
Show roles where <select name="role_search_field">
<?php
    $search_fields= array('role_title' => 'Role Title', 'role_key' => 'Role Key');
    foreach($search_fields as $field => $name) {
        $selected= "";
        if ($field == $search_field) { $selected= "selected ";}
        print "<option value=\"$field\" $selected>$name";
    }
?>
  </select>
  <select name="role_search_func">
<?php
    $search_funcs= array(1 => 'is', 2 => 'starts with', 3 => 'ends with', 4 => 'contains');
    foreach($search_funcs as $func => $name) {
        $selected= "";
        if ($func == $search_func) { $selected= "selected ";}
        print "<option value=\"$func\" $selected>$name";
    }
?>
  </select>
  <input type="text" name="role_search_value" value="<?= $search_value ?>">
  <input type="button" value="Search" onClick="do_search()" />
  <input type="button" value="All" onClick="clear_search()"/>
<!-- SEARCH FUNCTION END -->
<br/>
<!-- PAGE COUNT BEGIN -->
<?= $n_roles ?> <?php if ($is_search) { print "(of " . $total_roles . ") "; } ?>
roles (<select name="limit_count_list" onChange="change_limit_count()">
<?php
    // drop down list 10, 25, 50, 100, 200
    $limit_counts= array( 10, 25, 50, 100, 200 );
    foreach( $limit_counts as $count ) {
        $selected= "";
        if ($count == $limit_count) $selected= "selected ";
        print "<option value=\"$count\" $selected>$count";
    }
?>
</select>
roles/page on <?= $n_pages ?> pages)<br>

</form>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>
 <p/>
  


<form name="form_res_list" action="delete-role.php" method="POST">
  
  <table width="100%" border="0" cellspacing="0" class="data-table">

    <!-- ************  table header ********************** -->
    <tr>
      <th class="data" width="5"></th>
      <th class="data" >Role Title [Role Key]</th>
      <th class="data" colspan="2">Subscription Requests</th>
      <th class="data last">Actions</th>
    </tr>  
    <tr>
      <th class="data" width="5"></th>
      <th class="data">&nbsp;</th>
      <th class="data">Pending</th>
      <th class="data">Processed</th>
      <th class="data last"></th>
    </tr>  

    <!-- ************  / table header ********************** -->
  
    
   <?php
     // fetch roles from the database
     // 
     $role_ids= $admin->getMyRoleIDs($search_field,$search_sql_value,$limit_offset,$limit_count);
     $i = 0;
     //  the main role loop
     //
   ?>
   <?php if (empty($role_ids)): ?>
     <tr>      
      <td width="100%" valign="top" class="data-odd last" colspan="5">
      <?php if ($is_search): ?>
        None of your role match the filter criteria, click on All.
      <?php else: ?>
        You did not have any role yet. See the menu on the left and chose 
        <a href="list-all-roles.php">All Roles</a>.
      <?php endif; ?>
      </td>
     </tr>
   <?php else: ?>
        
     <?php foreach($role_ids as $role_id): ?>
       <?php
       
       $role=& Role::reconstituteById( $role_id );       
       // which style to use for the table row background ?
       $style = ($i++ % 2 == 0) ? "data-even" : "data-odd";
       
       // fetch information about pending and processed role 
       // subscriptions from the database
       $sub_status= $role->getRoleSubscriptionStatus();
       $num_pending= $sub_status['pending'];
       $num_processed= $sub_status['processed']; 
       
       
       // mark rows with at least one pending subscription request
       //
       if ($num_pending > 0) {$style_tag = " style='background-color: rgb(254,205,208);' "; }
       else {$style_tag = "";}
       ?>
     
    <tr>
      <!-- ************ checkbox column ************* -->
      <td width="5" valign="top" class="<?= $style ?>">
        <input type="checkbox" name="res-<?= $role_id ?>" /> 
      </td>
    
      <!-- ************ role title column ************* -->
      <td width="40%" valign="top" class="<?= $style ?>">
      <?= $role->getTitle() ?> [<?= $role->getRoleKey() ?>]
      </td>
    
      <!-- ************ number of pending messages column ************* -->
      <td width="10%" valign="top" class="<?= $style ?>" <?= $style_tag ?> >
        <?= $num_pending ?> 
      </td>
    
      <!-- ************ number of processed messages column ************* -->
      <td width="10%" valign="top" class="<?= $style ?>">
        <?= $num_processed ?>
      </td>

      <!-- ************ actions column ************* -->    
      <td align="center" valign="top" class="<?= $style ?> last">
      
        <a href="list-subscriptions.php?rid=<?= $role_id ?>" title="List Subscriptions">Subscriptions</a> 
      | <a href="new-invitation.php?rid=<?= $role_id ?>" title="Send Invitations">Invitations</a> 
      <?php if ($admin->canEditRole($role)): ?>
      <br> <a href="edit-role.php?rid=<?= $role_id ?>" title="Edit Role">Edit</a> 
      | <a href="copy-role.php?rid=<?= $role_id ?>" title="Duplicate Role">Copy</a> 
      | <a href="javascript:delete_role(<?= $role_id ?>)" title="Delete Role">Delete</a>
      | <a href="edit-role-managers.php?rid=<?= $role_id ?>" title="Manage Role Administrators">Admins</a>
      <?php else: ?>
      | <a href="show-role.php?rid=<?= $role_id ?>" title="View Role">Details</a> 
      <?php endif; ?>
      </td>    
    </tr>
 
   <?php endforeach; ?>
   
    <?php if ( !Session::isSubscriptionAdministratorSession() ): ?>

    <!-- *************** last row with summary actions *************** -->
    <tr>
      <td colspan="2" class="data-even">
        <a href="javascript:select_all_roles()">Select All</a> 
        | <a href="javascript:unselect_all_roles()">Unselect All</a>
      </td>
      <td colspan="3" class="data-even last">
         &nbsp;
      </td>
    </tr>
    <!-- *************** / last row with summary actions *************** -->
    
    <!-- *************** action buttons *************** -->    
    <tr>
      <td colspan="5" class="form-control">
        <input type="button" value="Delete Selected" onClick="delete_selected_roles()" />
      </td>
    </tr>    
    <!-- *************** / action buttons *************** -->
    <?php endif; ?>

  <?php endif; ?>

   </table>   
 </form>
<p>
 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>
 <p/>
 

<?php
include("include/adminFooter.inc");
?>
