<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: admin-header.inc,v 1.6 2006/09/28 12:49:24 vlry Exp $
 */
/* ****************************************************************** */

/* ********************************************************************** */
/*                          includes                                      */
/* ********************************************************************** */
require_once("include/application.inc");
require_once("lookandfeel/current/lf-specific-functions.inc");

/* ********************************************************************** */
/*                          content                                       */
/* ********************************************************************** */
?>
<html>
<head>
<title>SNAportal Administration</title>
<link rel="stylesheet" href="<?= lf_get_admin_style_sheet_url() ?>" type="text/css">
</head>

<body>
<!-- ***************** page header ******************  -->
<table width="100%" border="0" cellspacing="0" class="ph">
<tr>
  <td class="ph-app-name" align="left">SNAportal <?= SNA_PORTAL_VERSION ?></td>
  <td class="ph-user-name" align="right">Admin: <?= lf_get_admin_user_name() ?> (<?= lf_get_admin_user_role() ?>)</td>
</tr>
</table>
<!-- ***************** / page header ******************  -->


<table width="100%" height="100%" border="0" cellspacing="0" class="main">
<tr>
  <td width="180" valign="top" class="menu">
  
  
  <!-- menu -->
  <table width="100%" border="0" cellspacing="0" class="menu" height="100%" >
  <tr>
    <td class="menu-main-item"><a href="<?= PORTAL_BASE_URL ?>/admin/start-page.php">Home</a></td>
  </tr>

  <tr>
    <td class="menu-main-item">Role Management</td>
  </tr>

  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-my-roles.php">My Roles</a></td>
  </tr>

  <?php if ( ! Session::isSubscriptionAdministratorSession()): ?>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/new-role.php">Add a Role</a></td>
  </tr>
  <?php endif; ?>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-all-roles.php">All Roles</a></td>
  </tr>

  <tr>
    <td class="menu-main-item">User Management</td>
  </tr>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/change-profile.php">My Profile</a>
    <?php
        I18N::initLocale();
        $locale= I18N::getLocale();
    ?>
     (<a href="<?= PORTAL_BASE_URL ?>/admin/change-language.php">Lang: <?= $locale ?></a>)</td>
  </tr>

  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-my-users.php">My Users</a></td>
  </tr>

  <?php if (Session::isPortalAdministratorSession()): ?>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/new-user.php">Add a User</a></td>
  </tr>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-all-users.php">All Users</a></td>
  </tr>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-orphan-users.php">All Orphans</a></td>
  </tr>
  <?php endif; ?>

  <?php if (Session::isPortalAdministratorSession()): ?>
  <tr>
     <td class="menu-main-item">Actions</td>
  </tr>
  <tr>
      <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-actions.php">All Actions</a></td>
  </tr>
  <tr>
      <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/add-action.php">Add Actions</a></td>
  </tr>


  <?php endif; ?>


  <tr>
    <td class="menu-main-item">Status</td>
  </tr>
  <?php if (Session::isPortalAdministratorSession()):
    $enableEvents= true;
    if (defined('ENABLE_EVENTS')) {
        $enableEvents= ENABLE_EVENTS;
    } 
  ?>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/list-events.php">Events Viewer</a> (<b><?= $enableEvents ? 'On' : 'Off' ?></b>)</td>
  </tr>
  <?php endif; ?>
  <tr>
    <td class="menu-sub-item">Email Notifications (<b><?= ENABLE_NOTIFICATION ? 'On' : 'Off' ?></b>)</td>
  </tr>
  <?php if (Session::isPortalAdministratorSession()): ?>
  <tr>
    <td class="menu-sub-item"><a href="<?= PORTAL_BASE_URL ?>/admin/php-info.php">PHP Info</a></td>
  </tr>
  <?php endif; ?>

  <tr>
    <td class="menu-main-item"><a href="<?= PORTAL_BASE_URL ?>/admin/logout.php?url=<?= PORTAL_BASE_URL ?>/index.php">Logout</a></td>    
  </tr>

  <tr>
    <td height="100%" class="menu-filler">
    </td>
  </tr>
 

  </table>
  <!-- / menu -->
  
  
  </td>
  
  
  <td width="*" valign="top" class="content">
