<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: lf-specific-functions.inc,v 1.3 2006/09/06 16:10:26 vlry Exp $
 */
/* ****************************************************************** */

require_once("include/constants.inc");
  
/* ****************************************************************** */
/*
* lf_get_user_style_sheet_url - replies the URL to the style sheet
*   to be used
*
* RETURN
*   the URL to the style sheet to be used 
*
* DEPENDENCIES 
*   
*/
function lf_get_user_style_sheet_url()
{
  return PORTAL_BASE_URL . "/lookandfeel/current/styles-user.css";
}

/* ****************************************************************** */
/*
* lf_get_admin_style_sheet_url - replies the URL to the style sheet
*   used in the admin part of the AAI portal  
*
* RETURN
*   the URL to the style sheet to be used
*
*/
function lf_get_admin_style_sheet_url()
{
  return PORTAL_BASE_URL . "/lookandfeel/current/styles-admin.css";
}



/* ****************************************************************** */
/*
* lf_get_user_name - replies the user name to be displayed in the
* page header 
*
* RETURN
*   the user name to be displayed in the page header 
*
* DEPENDENCIES 
*   - depends on the correct values in the $_SESSION variable
*   
*/

function lf_get_user_name()
{
//  return $_SESSION['aai_givenName']  . " " . $_SESSION['aai_surname'];
    return $_SESSION['displayName'];
}


function lf_get_admin_user_name()
{
  return $_SESSION['displayName'];
}

function lf_get_admin_user_role() 
{
  return $_SESSION['privilegeName'];
}
?>
