<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: all-roles.php,v 1.24 2007/03/06 17:22:02 vlry Exp $
 */
/* ****************************************************************** */

/**
* This page displays a list of available roles.
*
* @version $Revision: 1.24 $
* @package UserPortal
*/

/**
 */

require_once("include/application.inc");

// start session and ensure access restrictions
Session::ensureUserSessionValid();
I18N::initLocale();
I18N::loadMessageBundle("user/all-roles");

//
// make sure the current user exists
//
$uid= Session::getUID();
$user=& User::reconstituteByUid($uid);
if (! $user) {
    ErrorHandling::fatalErrorAndExit("Could not reconstitute user: $uid");
}


// include common header
//
include("include/header.inc");
?>
  <h1><?= I18N::getMessage("all-roles.pagetitle") ?></h1> 

  <?= I18N::getMessage("all-roles.text1") ?>
  <p/>        
  
  
  <table width="90%" border="0" cellspacing="0" class="data-table">
    <tr>
      <th class="data" width="40%" valign="top"><?= I18N::getMessage("all-roles.table1.coltitle1") ?></th>
      <th class="data" width="30%"><?= I18N::getMessage("all-roles.table1.coltitle2") ?></th>
      <th class="data last" width="30%"><?= I18N::getMessage("all-roles.table1.coltitle3") ?></th>
    </tr>  

  <?php $visibleRoles =& Role::getVisibleRoles(); ?>
  <?php if (! $visibleRoles || count($visibleRoles) == 0): ?>
    <tr>
      <td width="100%" valign="top" class="data-odd" colspan=3>
      <?= I18N::getMessage("all-roles.no-res") ?>
      </td>
    </tr>
    
  <?php else: ?>

    <?php 
       $my_roles = $user->getSubscribedRoleIDs();
     ?>
     <?php for ($i=0; $i < count($visibleRoles); $i++): ?>
       <?php 
           $role = $visibleRoles[$i];
           $style = ($i % 2 == 0) ? "data-even" : "data-odd";
       ?>
	    <tr>
	      <td width="40%" valign="top" class="<?= $style ?>">
	         <?= $role["role_title"] ?>
	      </td>
	      <td width="30%" valign="top" class="<?= $style ?>">
	        <?php if (in_array($role["role_id"], $my_roles)):  ?>
                  <?= I18N::getMessage("all-roles.resstate.subscribed") ?>
	        <?php elseif ($role["role_state"] == RESOURCE_ACCESS_STATE_PASSWORD): ?>
                  <?= I18N::getMessage("all-roles.resstate.password") ?>
	        <?php elseif ($role["role_state"] == RESOURCE_ACCESS_STATE_FREE): ?>
                  <?= I18N::getMessage("all-roles.resstate.free") ?>
	        <?php elseif ($role["role_state"] != RESOURCE_ACCESS_STATE_CLOSED): ?>
                  <?= I18N::getMessage("all-roles.resstate.open") ?>
	        <?php else: ?>
                  <?= I18N::getMessage("all-roles.resstate.closed") ?>
	        <?php endif; ?>
	      </td>
	      <td width="30%" valign="top" class="<?= $style ?> last">
	      <a href="<?= PORTAL_BASE_URL . "/user/role-details.php?rid=" . $role["role_id"] ?>"><?= I18N::getMessage("all-roles.act.view-details") ?></a>&nbsp; 
	      <?php if ($role["role_state"] != RESOURCE_ACCESS_STATE_CLOSED 	 && ! in_array($role["role_id"], $my_roles)): ?>
	        | &nbsp; <a href="subscribe.php?rid=<?= $role["role_id"] ?>"><?= I18N::getMessage("all-roles.act.subscribe") ?></a>
	      <?php endif; ?>
	      </td>
	    </tr>
    <?php endfor; ?>    
  <?php endif; ?>  
</table>


<?php
// include common footer
//
include("include/footer.inc");
?>
