<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2005 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: logout.php,v 1.13 2005/02/26 11:15:54 vlry Exp $
 */


/**
* This page is invoked when a user wants to logout from the SNA-Portal.
*
* <b>Request Parameters</b>
* <ul>
*  <li>url=<follow-up-url>: OPTIONAL. If present, there is is redirected to
*       <follow-up-url> after the logout. If missing an HTML page including
*       a short notice that the user is now logged out, is displayed.
*  </li>
* </ul>
*
* @version $Revision: 1.13 $
* @package UserPortal
*/

//
// bootstrap application 
//
require_once("include/application.inc");
require_once("lookandfeel/current/lf-specific-functions.inc");

//
// destroy the current session
//
Session::destroy();

// redirect to user login page
if (isset($_REQUEST["url"])) {
  header('Location: ' . $_REQUEST["url"]);
  exit;
}
?>
<html>
<head>
<link rel="stylesheet" href="<?= lf_get_user_style_sheet_url() ?>" type="text/css">
</head>
<body>
<div align="center" style="margin-top: 2cm">
  <table width="40%" border="0" cellspacing="0" class="data-table">
    <tr>
      <th class="data" width="40%" valign="top">Logout </th>
    </tr>  
    <tr>
      <td width="30%" valign="top" class="data-odd last" align="center" style="padding-top: 10; padding-bottom: 10pt">
      You are logged out. <a href="<?= PORTAL_BASE_URL ?>">Login</a> again ?
      </td>
    </tr>
  </table>
</div>
</body>
</html>
