<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: start-page.php,v 1.20 2005/02/24 14:27:43 vlry Exp $
 */
/* ****************************************************************** */

/**
* This is the start page with personalized summary information.
*
* @version $Revision: 1.20 $
* @package UserPortal
*/

/**
 */



/**
* The max. number of subscribed roles shown on this page. 
*/
if (!defined("MAX_NUM_SUBSCRIBED_RESOURCES")) {
  define(MAX_NUM_SUBSCRIBED_RESOURCES, 7);	
}

/**
* The max. number of new roles shown on this page. 
*/

if (! defined("MAX_NUM_NEW_RESOURCES")) {
  define(MAX_NUM_NEW_RESOURCES,        5);
}



// bootstrap application
//
require_once("include/application.inc");

// start session
//
Session::ensureUserSessionValid();
I18N::initLocale();
I18N::loadMessageBundle("user/start-page");
	
//
// make sure the current user exists
//
$uid= Session::getUID();
$user=& User::reconstituteByUid($uid);
if (is_null($user)) {
    ErrorHandling::fatalErrorAndExit("Could not reconstitute user: $uid");
}

// include the page header
//
include("include/header.inc");
?>
  <p class="welcome-title"><?= I18N::getMessage("start-page.pagetitle") ?></p>
  <?= I18N::getMessage("start-page.welcometext") ?>
  


 <?php /* ************************************************************** */ ?>
 <h1><?= I18N::getMessage("start-page.subtitle1") ?></h1>


  <table width="90%" border="0" cellspacing="0" class="data-table">

    <tr>
      <th class="data" width="40%" valign="top"><?= I18N::getMessage("start-page.table1.coltitle1") ?></th>
      <th class="data" width="30%"><?= I18N::getMessage("start-page.table1.coltitle2") ?></th>
      <th class="data last" width="30%"><?= I18N::getMessage("start-page.table1.coltitle3") ?></th>
    </tr>

  <?php $roles = $user->getAccessibleRoles(); ?>
  <?php if (! $roles ||  count($roles) == 0): ?>
    <tr>
      <td width="100%" valign="top" class="data-odd last" colspan=3 align=center>
      <?= I18N::getMessage("start-page.no-sub-res") ?>
      </td>
    </tr>

  <?php else: ?>
  <?php
	$numSubscribedRoles = count($roles);
	$maxShown = min($numSubscribedRoles, MAX_NUM_SUBSCRIBED_RESOURCES);
	?>
	
	<?php for ($i=0; $i < $maxShown; $i++): ?>
	   <?php
	   $role_info = $roles[$i];
	   $style = ($i % 2 == 0) ? "data-even" : "data-odd";
     ?>
    <tr>
      <td width="40%" valign="top" class="<?= $style ?>"><?= $role_info["role_title"] ?>      
      &nbsp;<a href="go.php?rid=<?= $role_info["role_id"] ?>" target="role"><img src="<?= PORTAL_BASE_URL . "/lookandfeel/current/go.gif" ?>" border="0" alt="Goto role"></a>
      </td>
      <td width="30%" valign="top" class="<?= $style ?>">
         <?= Formatting::formatMysqlDate($role_info["subscription_last_login"], true) ?>
      </td>
      <td width="30%" valign="top" class="<?= $style ?> last">
      <a href="role-details.php?rid=<?= $role_info["role_id"] ?>"><?= I18N::getMessage("start-page.act.view-details") ?></a>
      | <a href="unsubscribe.php?rid=<?= $role_info["role_id"] ?>&url=start-page.php"><?= I18N::getMessage("start-page.act.unsubscribe") ?></a>
      </td>
    </tr>
   <?php endfor; ?>
  
  <?php if ($maxShown < $numSubscribedRoles): ?>
    <tr>
      <td colspan=3 valign="top" class="data-more"><a href="my-roles.php"><?= I18N::getMessage("start-page.more-sub-res") ?></a></td>
    </tr>    
  <?php endif; ?>
<?php endif; ?>  


</table> 


  <?php /* ************************************************************** */ ?>
  <h1><?= I18N::getMessage("start-page.subtitle2") ?></h1>

  <?php $roles =& Role::getRecentlyAddedRoles($user->user_id, MAX_NUM_NEW_RESOURCES); ?>
  
  <table width="90%" border="0" cellspacing="0" class="data-table">
    <tr>
      <th class="data" width="40%" valign="top"><?= I18N::getMessage("start-page.table2.coltitle1") ?></th>
      <th class="data" width="30%"><?= I18N::getMessage("start-page.table2.coltitle2") ?></th>
      <th class="data last" width="30%"><?= I18N::getMessage("start-page.table2.coltitle3") ?></th>
    </tr>  
 
    <?php if (! $roles || count($roles) == 0): ?>
    <tr>
      <td width="100%" valign="top" class="data-odd last" colspan=3 align=center>
      <?= I18N::getMessage("start-page.no-res") ?>
      </td>
    </tr>


    <?php else: ?>
       <?php
         $maxShown = min(count($roles), MAX_NUM_NEW_RESOURCES);
       ?>
       <?php for ($i=0; $i < $maxShown; $i++): ?>
         <?php 
           $role_info = $roles[$i];
           $style = ($i % 2 == 0) ? "data-even" : "data-odd";
         ?>
         <tr>
		      <td width="40%" valign="top" class="<?= $style ?>">
		         <?= $role_info["role_title"] ?>
		      </td>
		      <td width="30%" valign="top" class="<?= $style ?>">
		         <?= Formatting::formatMySqlDate($role_info["date_created"]) ?>
		      </td>
		      <td width="30%" valign="top" class="<?= $style ?> last">
		      <a href="role-details.php?rid=<?= $role_info["role_id"] ?>"><?= I18N::getMessage("start-page.act.view-details") ?></a>
		      | <a href="subscribe.php?rid=<?= $role_info["role_id"] ?>"><?= I18N::getMessage("start-page.act.subscribe") ?></a>
		      </td>
		    </tr> 
       <?php endfor; ?>
    <?php endif; ?>
    
    
    <tr>
      <td colspan=3 valign="top" class="data-more">
           <a href="all-roles.php"><?= I18N::getMessage("start-page.more-res") ?></a>
      </td>
    </tr>
  
  </table>  
  </td>
</tr>
</table>


<?php
// include the common footer
//
include("include/footer.inc");
?>
